Table editor

Vue Bootstrap 5 Table editor plugin

Table Editor is a useful tool for displaying and managing data. The component works similarly to the Datatable (docs) with an additional column for action buttons.

Responsive interactive built with the latest Bootstrap 5 and Vue 3. Creates editable tables. Delete or edit rows directly or via modal editor.

Note: Read the API tab to find all available options and advanced customization


Basic example

You can initialize the component via MDBTableEditor.You can pass the data to the component in two ways. First is to bind the data with an array of columns and rows to the dataset property. Second way is to create a HTML markup for your table inside MDBDatatable component - you can customize your table later by adding props to the component. Some of the more advanced options for columns, can be also used by setting data-mdb-attributes directly to a th tag (f.e. <th data-mdb-sort="false">).

When edit mode is enabled, the user shouldn't be able to interact with other parts of your website, as it can lead to loss of unsaved changes. You can control disabled state with v-model:edit property binding or by listening to edit and exit events.

Note: search field and add button are not a build-in part of Table Editor.

Table Editor collects information from HTML markup to create a data structure - the <table> element will be replaced in the DOM with a different node after component initializes.


Company Address Employees
Smith & Johnson Park Lane 2, London 30
P.J. Company Oak Street 7, Aberdeen 80
Food & Wine Netherhall Gardens 3, Hampstead 12
IT Service Warwick Road 14, London 17
A. Jonson Gallery Oaklands Avenue 2, London 4
F.A. Architects Frognal Way 7, Hampstead 4
        
            
            <template>
              <div class="d-flex justify-content-end mb-4">
                <MDBInput
                  v-model="basicSearch"
                  label="Search"
                  :disabled="basicEdit"
                />
                <MDBBtn
                  color="primary"
                  size="sm"
                  class="ms-3"
                  @click="basicEditorRef?.addRow()"
                  :disabled="basicEdit"
                >
                  <MDBIcon icon="plus"/>
                </MDBBtn>
              </div>
              <hr />
              <MDBTableEditor
                :search="basicSearch"
                :entries="5"
                :entriesOptions="[5, 10, 15]"
                v-model:edit="basicEdit"
                ref="basicEditorRef"
              >
                <table class="table">
                  <thead>
                    <tr>
                      <th class="th-sm" data-mdb-width="250">Company</th>
                      <th class="th-sm" data-mdb-width="250" data-mdb-sort="false">
                        Address
                      </th>
                      <th class="th-sm" data-mdb-width="250" data-mdb-sort="false">
                        Employees
                      </th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr>
                      <td>Smith & Johnson</td>
                      <td>Park Lane 2, London</td>
                      <td>30</td>
                    </tr>
                    <tr>
                      <td>P.J. Company</td>
                      <td>Oak Street 7, Aberdeen</td>
                      <td>80</td>
                    </tr>
                    <tr>
                      <td>Food & Wine</td>
                      <td>Netherhall Gardens 3, Hampstead</td>
                      <td>12</td>
                    </tr>
                    <tr>
                      <td>IT Service</td>
                      <td>Warwick Road 14, London</td>
                      <td>17</td>
                    </tr>
                    <tr>
                      <td>A. Jonson Gallery</td>
                      <td>Oaklands Avenue 2, London</td>
                      <td>4</td>
                    </tr>
                    <tr>
                      <td>F.A. Architects</td>
                      <td>Frognal Way 7, Hampstead</td>
                      <td>4</td>
                    </tr>
                  </tbody>
                </table>
              </MDBTableEditor>
            </template>
          
        
    
        
            
            <script>
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";
              export default {
                components: {
                  MDBInput, MDBBtn, MDBIcon, MDBTableEditor
                },
                setup() {
                  const basicEditorRef = ref(null);
                  const basicSearch = ref("");
                  const basicEdit = ref(false);

                  return {
                    basicEditorRef,
                    basicSearch,
                    basicEdit,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              const basicEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
              const basicSearch = ref("");
              const basicEdit = ref(false);
            </script>
          
        
    

Modal

To change the default editing mode (inline) to the modal version, set option mode to "modal".

        
            
            <template>
              <div class="d-flex justify-content-end mb-4">
                <MDBInput v-model="modalSearch" label="Search" :disabled="modalEdit" />
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  class="ms-3" 
                  @click="modalEditorRef?.addRow()" 
                  :disabled="modalEdit"
                >
                  <MDBIcon icon="plus"/>
                </MDBBtn>
              </div>
              <hr />
              <MDBTableEditor 
                mode="modal"
                v-model:dataset="modalData" 
                :search="modalSearch" 
                :entries="5"
                :entriesOptions="[5, 10, 15]" 
                v-model:edit="modalEdit" 
                ref="modalEditorRef" 
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";
              export default {
                components: {
                  MDBInput, MDBBtn, MDBIcon, MDBTableEditor
                },
                setup() {
                  const modalEditorRef = ref(null);
                  const modalSearch = ref("");
                  const modalEdit = ref(false);
                  const modalData = ref({
                    columns: [
                      {
                        width: 250,
                        label: "Company",
                        field: "company",
                      },
                      {
                        width: 250,
                        sort: false,
                        defaultValue: "Warsaw",
                        options: ["London", "Warsaw", "New York"],
                        inputType: "select",
                        label: "Office",
                        field: "office",
                      },
                      {
                        width: 250,
                        inputType: "number",
                        defaultValue: 1,
                        label: "Employees",
                        field: "employees",
                      },
                      {
                        width: 100,
                        defaultValue: false,
                        inputType: "checkbox",
                        label: "International",
                        field: "international",
                      },
                    ],
                    rows: [
                      {
                        company: "Smith & Johnson",
                        office: "London",
                        employees: 30,
                        international: true,
                      },
                      {
                        company: "P.J. Company",
                        office: "London",
                        employees: 80,
                        international: false,
                      },
                      {
                        company: "Food & Wine",
                        office: "London",
                        employees: 12,
                        international: false,
                      },
                      {
                        company: "IT Service",
                        office: "London",
                        employees: 17,
                        international: false,
                      },
                      {
                        company: "A. Jonson Gallery",
                        office: "London",
                        employees: 4,
                        international: false,
                      },
                      {
                        company: "F.A. Architects",
                        office: "London",
                        employees: 4,
                        international: false,
                      }
                    ]
                  });
                  return {
                    modalEditorRef,
                    modalSearch,
                    modalEdit,
                    modalData,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              const modalEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
              const modalSearch = ref("");
              const modalEdit = ref(false);
              const modalData = ref({
                columns: [
                  {
                    width: 250,
                    label: "Company",
                    field: "company",
                  },
                  {
                    width: 250,
                    sort: false,
                    defaultValue: "Warsaw",
                    options: ["London", "Warsaw", "New York"],
                    inputType: "select",
                    label: "Office",
                    field: "office",
                  },
                  {
                    width: 250,
                    inputType: "number",
                    defaultValue: 1,
                    label: "Employees",
                    field: "employees",
                  },
                  {
                    width: 100,
                    defaultValue: false,
                    inputType: "checkbox",
                    label: "International",
                    field: "international",
                  },
                ],
                rows: [
                  {
                    company: "Smith & Johnson",
                    office: "London",
                    employees: 30,
                    international: true,
                  },
                  {
                    company: "P.J. Company",
                    office: "London",
                    employees: 80,
                    international: false,
                  },
                  {
                    company: "Food & Wine",
                    office: "London",
                    employees: 12,
                    international: false,
                  },
                  {
                    company: "IT Service",
                    office: "London",
                    employees: 17,
                    international: false,
                  },
                  {
                    company: "A. Jonson Gallery",
                    office: "London",
                    employees: 4,
                    international: false,
                  },
                  {
                    company: "F.A. Architects",
                    office: "London",
                    employees: 4,
                    international: false,
                  }
                ]
              });
            </script>
          
        
    

Inputs example

Table Editor supports several input types - for example, if you wish to force a user to enter only Boolean values in one column, you can set its inputType to a checkbox.

Supported input types:

  • Text (default)
  • Number
  • Checkbox - displays a checkbox in edit mode and true/false value otherwise
  • Select - additionally requires an array of options
  • Autocomplete - additionally requires a filter method inside the filter property. Check the autocomplete page to see how it should look like
  • Datepicker - add props property to provide additional options to the datepicker
  • Timepicker - add props property to provide additional options to the datepicker
        
            
            <template>
              <div class="d-flex justify-content-end mb-4">
                <MDBInput v-model="inputsSearch" label="Search" :disabled="inputsEdit" />
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  class="ms-3" 
                  @click="inputsEditorRef?.addRow()" 
                  :disabled="inputsEdit"
                >
                  <MDBIcon icon="plus"/>
                </MDBBtn>
              </div>
              <hr />
              <MDBTableEditor 
                v-model:dataset="inputsData" 
                :search="inputsSearch" 
                :entries="5" 
                :entriesOptions="[5, 10, 15]"
                v-model:edit="inputsEdit" 
                ref="inputsEditorRef" 
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              export default {
                components: {
                  MDBInput, MDBBtn, MDBIcon, MDBTableEditor
                },
                setup() {
                  const inputsEditorRef = ref(null);
                  const inputsSearch = ref("");
                  const inputsEdit = ref(false);
                  const inputsData = ref({
                    columns: [
                      {
                        width: 250,
                        label: "Company",
                        field: "company",
                      },
                      {
                        width: 250,
                        sort: false,
                        defaultValue: "Warsaw",
                        options: ["London", "Warsaw", "New York"],
                        inputType: "select",
                        label: "Office",
                        field: "office",
                      },
                      {
                        width: 250,
                        inputType: "number",
                        defaultValue: 1,
                        label: "Employees",
                        field: "employees",
                      },
                      {
                        width: 100,
                        defaultValue: false,
                        inputType: "checkbox",
                        label: "International",
                        field: "international",
                      },
                    ],
                    rows: [
                      {
                        company: "Smith & Johnson",
                        office: "London",
                        employees: 30,
                        international: true,
                      },
                      {
                        company: "P.J. Company",
                        office: "London",
                        employees: 80,
                        international: false,
                      },
                      {
                        company: "Food & Wine",
                        office: "London",
                        employees: 12,
                        international: false,
                      },
                      {
                        company: "IT Service",
                        office: "London",
                        employees: 17,
                        international: false,
                      },
                      {
                        company: "A. Jonson Gallery",
                        office: "London",
                        employees: 4,
                        international: false,
                      },
                      {
                        company: "F.A. Architects",
                        office: "London",
                        employees: 4,
                        international: false,
                      }
                    ]
                  });

                  return {
                    inputsEdit,
                    inputsEditorRef,
                    inputsSearch,
                    inputsData,
                  }
                }
              }
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              const inputsEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
              const inputsSearch = ref("");
              const inputsEdit = ref(false);
              const inputsData = ref({
                columns: [
                  {
                    width: 250,
                    label: "Company",
                    field: "company",
                  },
                  {
                    width: 250,
                    sort: false,
                    defaultValue: "Warsaw",
                    options: ["London", "Warsaw", "New York"],
                    inputType: "select",
                    label: "Office",
                    field: "office",
                  },
                  {
                    width: 250,
                    inputType: "number",
                    defaultValue: 1,
                    label: "Employees",
                    field: "employees",
                  },
                  {
                    width: 100,
                    defaultValue: false,
                    inputType: "checkbox",
                    label: "International",
                    field: "international",
                  },
                ],
                rows: [
                  {
                    company: "Smith & Johnson",
                    office: "London",
                    employees: 30,
                    international: true,
                  },
                  {
                    company: "P.J. Company",
                    office: "London",
                    employees: 80,
                    international: false,
                  },
                  {
                    company: "Food & Wine",
                    office: "London",
                    employees: 12,
                    international: false,
                  },
                  {
                    company: "IT Service",
                    office: "London",
                    employees: 17,
                    international: false,
                  },
                  {
                    company: "A. Jonson Gallery",
                    office: "London",
                    employees: 4,
                    international: false,
                  },
                  {
                    company: "F.A. Architects",
                    office: "London",
                    employees: 4,
                    international: false,
                  }
                ]
              });
            </script>
          
        
    

Disable edit

You can disable editing for a column by setting its editable option to false. A user won't be able to change its value in the edit mode.

        
            
            <template>
              <div class="d-flex justify-content-end mb-4">
                <MDBInput v-model="disabledSearch" label="Search" :disabled="disabledEdit" />
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  class="ms-3" 
                  @click="disabledEditorRef?.addRow()" 
                  :disabled="disabledEdit"
                >
                  <MDBIcon icon="plus"/>
                </MDBBtn>
              </div>
              <hr />
              <MDBTableEditor 
                v-model:dataset="disabledData" 
                :search="disabledSearch" 
                :entries="5" 
                :entriesOptions="[5, 10, 15]"
                v-model:edit="disabledEdit" 
                ref="disabledEditorRef" 
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";
              
              export default {
                components: {
                  MDBInput, MDBBtn, MDBIcon, MDBTableEditor
                },
                setup() {
                  const disabledEditorRef = ref(null);
                  const disabledSearch = ref("");
                  const disabledEdit = ref(false);
                  const disabledData = ref({
                    columns: [
                      {
                        width: 250,
                        label: "Company",
                        field: "company",
                        editable: false
                      },
                      {
                        width: 250,
                        sort: false,
                        defaultValue: "Warsaw",
                        options: ["London", "Warsaw", "New York"],
                        inputType: "select",
                        label: "Office",
                        field: "office",
                        editable: false
                      },
                      {
                        width: 250,
                        inputType: "number",
                        defaultValue: 1,
                        label: "Employees",
                        field: "employees",
                        editable: false
                      },
                      {
                        width: 100,
                        defaultValue: false,
                        inputType: "checkbox",
                        label: "International",
                        field: "international",
                        editable: false
                      },
                    ],
                    rows: [
                      {
                        company: "Smith & Johnson",
                        office: "London",
                        employees: 30,
                        international: true,
                      },
                      {
                        company: "P.J. Company",
                        office: "London",
                        employees: 80,
                        international: false,
                      },
                      {
                        company: "Food & Wine",
                        office: "London",
                        employees: 12,
                        international: false,
                      },
                      {
                        company: "IT Service",
                        office: "London",
                        employees: 17,
                        international: false,
                      },
                      {
                        company: "A. Jonson Gallery",
                        office: "London",
                        employees: 4,
                        international: false,
                      },
                      {
                        company: "F.A. Architects",
                        office: "London",
                        employees: 4,
                        international: false,
                      }
                    ]
                  });
                  
                  return {
                    disabledEditorRef,
                    disabledSearch,
                    disabledEdit,
                    disabledData,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              const disabledEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
              const disabledSearch = ref("");
              const disabledEdit = ref(false);
              const disabledData = ref({
                columns: [
                  {
                     width: 250,
                    label: "Company",
                    field: "company",
                    editable: false
                  },
                  {
                    width: 250,
                    sort: false,
                    defaultValue: "Warsaw",
                    options: ["London", "Warsaw", "New York"],
                    inputType: "select",
                    label: "Office",
                    field: "office",
                    editable: false
                  },
                  {
                    width: 250,
                    inputType: "number",
                    defaultValue: 1,
                    label: "Employees",
                    field: "employees",
                    editable: false
                  },
                  {
                    width: 100,
                    defaultValue: false,
                    inputType: "checkbox",
                    label: "International",
                    field: "international",
                    editable: false
                  },
                ],
                rows: [
                  {
                    company: "Smith & Johnson",
                    office: "London",
                    employees: 30,
                    international: true,
                  },
                  {
                    company: "P.J. Company",
                    office: "London",
                    employees: 80,
                    international: false,
                  },
                  {
                    company: "Food & Wine",
                    office: "London",
                    employees: 12,
                    international: false,
                  },
                  {
                    company: "IT Service",
                    office: "London",
                    employees: 17,
                    international: false,
                  },
                  {
                    company: "A. Jonson Gallery",
                    office: "London",
                    employees: 4,
                    international: false,
                  },
                  {
                    company: "F.A. Architects",
                    office: "London",
                    employees: 4,
                    international: false,
                  }
                ]
              });
            </script>
          
        
    

Confirm delete

If you want to prevent data from being accidentally removed, you can set a confirm option to true. In this case, Table Editor will show a Popconfirm element before removing an entry.

        
            
            <template>
              <div class="d-flex justify-content-end mb-4">
                <MDBInput v-model="confirmSearch" label="Search" :disabled="confirmEdit" />
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  class="ms-3" 
                  @click="confirmEditorRef?.addRow()" 
                  :disabled="confirmEdit"
                >
                  <MDBIcon icon="plus"/>
                </MDBBtn>
              </div>
              <hr />
              <MDBTableEditor 
                confirm 
                v-model:dataset="confirmData" 
                :search="confirmSearch" 
                :entries="5" 
                :entriesOptions="[5, 10, 15]"
                v-model:edit="confirmEdit" 
                ref="confirmEditorRef" 
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              export default {
                components: {
                  MDBInput, MDBBtn, MDBIcon, MDBTableEditor
                },
                setup() {
                  const confirmEditorRef = ref(null);
                  const confirmSearch = ref("");
                  const confirmEdit = ref(false);
                  const confirmData = ref({
                    columns: [
                      {
                        width: 250,
                        label: "Company",
                        field: "company"
                      },
                      {
                        width: 250,
                        sort: false,
                        defaultValue: "Warsaw",
                        options: ["London", "Warsaw", "New York"],
                        inputType: "select",
                        label: "Office",
                        field: "office"
                      },
                      {
                        width: 250,
                        inputType: "number",
                        defaultValue: 1,
                        label: "Employees",
                        field: "employees"
                      },
                      {
                        width: 100,
                        defaultValue: false,
                        inputType: "checkbox",
                        label: "International",
                        field: "international"
                      },
                    ],
                    rows: [
                      {
                        company: "Smith & Johnson",
                        office: "London",
                        employees: 30,
                        international: true,
                      },
                      {
                        company: "P.J. Company",
                        office: "London",
                        employees: 80,
                        international: false,
                      },
                      {
                        company: "Food & Wine",
                        office: "London",
                        employees: 12,
                        international: false,
                      },
                      {
                        company: "IT Service",
                        office: "London",
                        employees: 17,
                        international: false,
                      },
                      {
                        company: "A. Jonson Gallery",
                        office: "London",
                        employees: 4,
                        international: false,
                      },
                      {
                        company: "F.A. Architects",
                        office: "London",
                        employees: 4,
                        international: false,
                      }
                    ]
                  });
                  
                  return {
                    confirmEditorRef,
                    confirmSearch,
                    confirmEdit,
                    confirmData,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              const confirmEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
              const confirmSearch = ref("");
              const confirmEdit = ref(false);
              const confirmData = ref({
                columns: [
                  {
                    width: 250,
                    label: "Company",
                    field: "company"
                  },
                  {
                    width: 250,
                    sort: false,
                    defaultValue: "Warsaw",
                    options: ["London", "Warsaw", "New York"],
                    inputType: "select",
                    label: "Office",
                    field: "office"
                  },
                  {
                    width: 250,
                    inputType: "number",
                    defaultValue: 1,
                    label: "Employees",
                    field: "employees"
                  },
                  {
                    width: 100,
                    defaultValue: false,
                    inputType: "checkbox",
                    label: "International",
                    field: "international"
                  },
                ],
                rows: [
                  {
                    company: "Smith & Johnson",
                    office: "London",
                    employees: 30,
                    international: true,
                  },
                  {
                    company: "P.J. Company",
                    office: "London",
                    employees: 80,
                    international: false,
                  },
                  {
                    company: "Food & Wine",
                    office: "London",
                    employees: 12,
                    international: false,
                  },
                  {
                    company: "IT Service",
                    office: "London",
                    employees: 17,
                    international: false,
                  },
                  {
                    company: "A. Jonson Gallery",
                    office: "London",
                    employees: 4,
                    international: false,
                  },
                  {
                    company: "F.A. Architects",
                    office: "London",
                    employees: 4,
                    international: false,
                  }
                ]
              });
            </script>
          
        
    


Async data

While awaiting data from API, you can prevent a user from interacting with Table Editor by setting loading option to true.


        
            
            <template>
              <div class="d-flex justify-content-between mb-4">
                <MDBBtn color="primary" size="sm" @click="loadAsyncData">Load data</MDBBtn>
                <div class="d-flex justify-content-end">
                  <MDBInput v-model="asyncSearch" label="Search" :disabled="asyncEdit" />
                  <MDBBtn 
                    color="primary" 
                    size="sm" 
                    class="ms-3" 
                    @click="asyncEditorRef?.addRow()" 
                    :disabled="asyncEdit"
                  >
                    <MDBIcon icon="plus"/>
                  </MDBBtn>
                </div>
              </div>
              <hr />
              <MDBTableEditor 
                v-model:dataset="asyncData" 
                :search="asyncSearch" 
                :loading="loadingAsync" 
                v-model:edit="asyncEdit"
                ref="asyncEditorRef" 
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              export default {
                components: {
                  MDBInput, MDBBtn, MDBIcon, MDBTableEditor
                },
                setup() {
                  const asyncEditorRef = ref(null);
                  const asyncSearch = ref("");
                  const asyncEdit = ref(false);
                  const asyncData = ref({
                    columns: [
                      { label: "Company", field: "company" },
                      { label: "Email", field: "email" },
                      { label: "Name", field: "name" },
                      { label: "Phone", field: "phone" },
                    ],
                    rows: [],
                  });
                  const loadingAsync = ref(false);
                  const loadAsyncData = () => {
                    asyncData.value.rows = [];
                    loadingAsync.value = true;
                    fetch("https://jsonplaceholder.typicode.com/users")
                      .then((response) => response.json())
                      .then((data) => {
                        asyncData.value.rows = data.map((user) => ({
                          ...user,
                          address: `${user.address.city}, ${user.address.street}`,
                          company: user.company.name,
                        }));
                        loadingAsync.value = false;
                      });
                  }
                  
                  return {
                    asyncEditorRef,
                    asyncSearch,
                    asyncEdit,
                    asyncData,
                    loadingAsync,
                    loadAsyncData,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              const asyncEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
              const asyncSearch = ref("");
              const asyncEdit = ref(false);
              const asyncData = ref({
                columns: [
                  { label: "Company", field: "company" },
                  { label: "Email", field: "email" },
                  { label: "Name", field: "name" },
                  { label: "Phone", field: "phone" },
                ],
                rows: [],
              });
              const loadingAsync = ref(false);
              const loadAsyncData = () => {
                asyncData.value.rows = [];
                loadingAsync.value = true;
                fetch("https://jsonplaceholder.typicode.com/users")
                  .then((response) => response.json())
                  .then((data) => {
                    asyncData.value.rows = data.map((user) => ({
                      ...user,
                      address: `${user.address.city}, ${user.address.street}`,
                      company: user.company.name,
                    }));
                    loadingAsync.value = false;
                  });
              };
            </script>
          
        
    

Custom rows

The add() method takes an optional argument - a row which values will be preloaded into a new entry.

Note: for this particular use, a row has to be an object.

Note: as adding buttons are initialized manually, they won't be automatically disabled in the edit mode.

M.B.

(5 Avenue 26, New York)

Berkley & Clark

(43th Street 12, New York)

D&D Inc.

(14 Street 67, New York)

Thomas & Co.

(2 Avenue 54, New York)


        
            
            <template>
            <MDBRow>
              <MDBCol md="3" sm="6" class="p-3">
                <h4>M.B.</h4>
                <p>(5 Avenue 26, New York)</p>
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  @click="
                    customRowsEditorRef?.addRow({
                      company: 'M.B.',
                      address: '5 Avenue 26',
                      city: 'New York'
                    })
                  "
                >
                  Load into table
                </MDBBtn>
              </MDBCol>
              <MDBCol md="3" sm="6" class="p-3">
                <h4>Berkley & Clark</h4>
                <p>(43th Street 12, New York)</p>
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  @click="
                    customRowsEditorRef?.addRow({
                      company: 'Berkley & Clark',
                      address: '43th Street 12',
                      city: 'New York'
                    })
                  "
                >
                  Load into table
                </MDBBtn>
              </MDBCol>
              <MDBCol md="3" sm="6" class="p-3">
                <h4>D&D Inc.</h4>
                <p>(14 Street 67, New York)</p>
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  @click="
                    customRowsEditorRef?.addRow({
                      company: 'D&D Inc.',
                      address: '14 Street 67',
                      city: 'New York'
                    })
                  "
                >
                  Load into table
                </MDBBtn>
              </MDBCol>
              <MDBCol md="3" sm="6" class="p-3">
                <h4>Thomas & Co.</h4>
                <p>(2 Avenue 54, New York)</p>
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  @click="
                    customRowsEditorRef?.addRow({
                      company: 'Thomas & Co.',
                      address: '2 Avenue 54',
                      city: 'New York'
                    })
                  "
                >
                  Load into table
                </MDBBtn>
              </MDBCol>
            </MDBRow>
            <hr class="mt-3" />
            <MDBTableEditor 
              v-model:dataset="customRowsData" 
              :search="customRowsSearch" 
              v-model:edit="customRowsEdit"
              ref="customRowsEditorRef" 
            />
            </template>
          
        
    
        
            
            <script>
              import { MDBBtn, MDBCol, MDBRow } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";
              
              export default {
                components: {
                  MDBBtn, MDBCol, MDBRow, MDBTableEditor
                },
                setup() {
                  const customRowsEditorRef = ref(null);
                  const customRowsSearch = ref("");
                  const customRowsEdit = ref(false);
                  const customRowsData = ref({
                    columns: [
                      {
                        width: 250,
                        label: "Company",
                        field: "company",
                      },
                      {
                        width: 250,
                        label: "Address",
                        field: "address",
                      },
                      {
                        width: 250,
                        label: "City",
                        field: "city",
                      },
                    ],
                    rows: [
                      { company: "Smith & Johnson", address: "Park Lane 2", city: "London" },
                      { company: "P.J. Company", address: "Oak Street 7", city: "Aberdeen" },
                      {
                        company: "Food & Wine",
                        address: "Netherhall Gardens 3",
                        city: "Hampstead",
                      },
                      { company: "IT Service", address: "Warwick Road 14", city: "London" },
                      {
                        company: "A. Jonson Gallery",
                        address: "Oaklands Avenue 2",
                        city: "London",
                      },
                      {
                        company: "F.A. Architects",
                        address: "Frognal Way 7",
                        city: "Hampstead",
                      },
                    ],
                  });
                  return {
                    customRowsEditorRef,
                    customRowsSearch,
                    customRowsEdit,
                    customRowsData,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBBtn, MDBCol, MDBRow } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              const customRowsEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
              const customRowsSearch = ref("");
              const customRowsEdit = ref(false);
              const customRowsData = ref({
                columns: [
                  {
                    width: 250,
                    label: "Company",
                    field: "company",
                  },
                  {
                    width: 250,
                    label: "Address",
                    field: "address",
                  },
                  {
                    width: 250,
                    label: "City",
                    field: "city",
                  },
                ],
                rows: [
                  { company: "Smith & Johnson", address: "Park Lane 2", city: "London" },
                  { company: "P.J. Company", address: "Oak Street 7", city: "Aberdeen" },
                  {
                    company: "Food & Wine",
                    address: "Netherhall Gardens 3",
                    city: "Hampstead",
                  },
                  { company: "IT Service", address: "Warwick Road 14", city: "London" },
                  {
                    company: "A. Jonson Gallery",
                    address: "Oaklands Avenue 2",
                    city: "London",
                  },
                  {
                    company: "F.A. Architects",
                    address: "Frognal Way 7",
                    city: "Hampstead",
                  },
                ],
              });
            </script>
          
        
    

Notifications

In this example, handlers for custom events trigger notifications after adding/deleting/updating an entry.

        
            
            <template>
              <div class="d-flex justify-content-end mb-4">
                <MDBInput v-model="notificationsSearch" label="Search" :disabled="notificationsEdit" />
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  class="ms-3" 
                  @click="notificationsEditorRef?.addRow()"
                  :disabled="notificationsEdit"
                >
                  <MDBIcon icon="plus"/>
                </MDBBtn>
              </div>
              <hr />
              <MDBTableEditor 
                v-model:dataset="notificationsData" 
                :search="notificationsSearch" 
                v-model:edit="notificationsEdit"
                ref="notificationsEditorRef" 
                @add="showNotification('success', 'New entry: ', $event)"
                @delete="showNotification('danger', 'Deleted entry: ', $event)" 
                @updateEntry="showNotification('primary', 'Updated entry: ', $event)"
              />
              <MDBAlert 
                v-model="alert" 
                :color="alertColor" 
                position="top-right" 
                width="360px" 
                :delay="2000" 
                autohide
              >
                <div v-html="alertMessage" />
              </MDBAlert>
            </template>
          
        
    
        
            
            <script>
              import { MDBInput, MDBBtn, MDBIcon, MDBAlert } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";
              
              export default {
                components: {
                  MDBInput, MDBBtn, MDBIcon, MDBAlert, MDBTableEditor
                },
                setup() {
                  const notificationsEditorRef = ref(null);
                  const notificationsSearch = ref("");
                  const notificationsEdit = ref(false);
                  const notificationsData = ref({
                    columns: [
                      {
                        width: 250,
                        label: "Company",
                        field: "company",
                      },
                      {
                        width: 250,
                        sort: false,
                        defaultValue: "Warsaw",
                        options: ["London", "Warsaw", "New York"],
                        inputType: "select",
                        label: "Office",
                        field: "office",
                      },
                      {
                        width: 250,
                        inputType: "number",
                        defaultValue: 1,
                        label: "Employees",
                        field: "employees",
                      },
                      {
                        width: 100,
                        defaultValue: false,
                        inputType: "checkbox",
                        label: "International",
                        field: "international",
                      },
                    ],
                    rows: [
                      {
                        company: "Smith & Johnson",
                        office: "London",
                        employees: 30,
                        international: true,
                      },
                      {
                        company: "P.J. Company",
                        office: "London",
                        employees: 80,
                        international: false,
                      },
                      {
                        company: "Food & Wine",
                        office: "London",
                        employees: 12,
                        international: false,
                      },
                      {
                        company: "IT Service",
                        office: "London",
                        employees: 17,
                        international: false,
                      },
                      {
                        company: "A. Jonson Gallery",
                        office: "London",
                        employees: 4,
                        international: false,
                      },
                      {
                        company: "F.A. Architects",
                        office: "London",
                        employees: 4,
                        international: false,
                      },
                    ]
                  });
                  const alert = ref(false);
                  const alertColor = ref("primary");
                  const alertMessage = ref("");
                  const showNotification = (type, message, event) => {
                    const { company, office } = event.row;
                    alertMessage.value = `<strong>${message}</strong> ${company} ${office}`;
                    alertColor.value = type;
                    alert.value = true;
                  };
                  return {
                    showNotification,
                    notificationsEditorRef,
                    notificationsSearch,
                    notificationsEdit,
                    notificationsData,
                    alert,
                    alertColor,
                    alertMessage,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBInput, MDBBtn, MDBIcon, MDBAlert } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              const notificationsEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
              const notificationsSearch = ref("");
              const notificationsEdit = ref(false);
              const notificationsData = ref({
                columns: [
                  {
                    width: 250,
                    label: "Company",
                    field: "company",
                  },
                  {
                    width: 250,
                    sort: false,
                    defaultValue: "Warsaw",
                    options: ["London", "Warsaw", "New York"],
                    inputType: "select",
                    label: "Office",
                    field: "office",
                  },
                  {
                    width: 250,
                    inputType: "number",
                    defaultValue: 1,
                    label: "Employees",
                    field: "employees",
                  },
                  {
                    width: 100,
                    defaultValue: false,
                    inputType: "checkbox",
                    label: "International",
                    field: "international",
                  },
                ],
                rows: [
                  {
                    company: "Smith & Johnson",
                    office: "London",
                    employees: 30,
                    international: true,
                  },
                  {
                    company: "P.J. Company",
                    office: "London",
                    employees: 80,
                    international: false,
                  },
                  {
                    company: "Food & Wine",
                    office: "London",
                    employees: 12,
                    international: false,
                  },
                  {
                    company: "IT Service",
                    office: "London",
                    employees: 17,
                    international: false,
                  },
                  {
                    company: "A. Jonson Gallery",
                    office: "London",
                    employees: 4,
                    international: false,
                  },
                  {
                    company: "F.A. Architects",
                    office: "London",
                    employees: 4,
                    international: false,
                  },
                ]
              });
              const alert = ref(false);
              const alertColor = ref("primary");
              const alertMessage = ref("");
              const showNotification = (type: string, message: string, event: Event) => {
                const { company, office } = event.row;
                alertMessage.value = `<strong>${message}</strong> ${company} ${office}`;
                alertColor.value = type;
                alert.value = true;
              };
            </script>
          
        
    

Table editor - API


Import

        
            
          <script>
            import { MDBTableEditor } from "mdb-vue-table-editor";
          </script>
        
        
    

Properties

Property Type Default Description
actionHeader String 'Actions' Header for action buttons
actionPosition String 'end' Decides where to render an action column (start/end)
allowEmptyCells Boolean false Allows to add empty cells in addRow method
bordered Boolean false Adds borders to a datatable
borderless Boolean false Removes all borders from a datatable
borderColor String Changes a border color to one of main colors
cancelText String 'Cancel' Text displayed in cancel buttons
confirm Boolean false Displays a Popconfirm element before removing an entry
confirmText String 'Cancel' Text displayed in confirm buttons (Popconfirm)
confirmMessage String 'Are you sure you want to delete this entry?' Text displayed in a Popconfirm element
color String Adds a color class to a datatable (f.e 'bg-dark')
defaultValue String "-" This string will be used as a placeholder if a row doesn't have a defined value for a column
dataset Object { columns: [], rows: [] } Main data object
v-model:edit Boolean false Keeps information about edit mode
entries Number 10 Number of visible entries (pagination)
entriesOptions Array [10, 25, 50, 200] Options available to choose from in a pagination select (rows per page)
fixedHeader Boolean false When it's set to true, the table's header will remain visible while scrolling
fullPagination Boolean false Displays additional buttons for the first and last pages
hover Boolean false Changes the background color of a hovered row
loaderClass String "bg-primary" The class name for a loader (loading mode)
loading Boolean false Sets the loading mode - disables interactions and displays a loader
loadingMessage String "Loading results..." A message displayed while loading data
maxHeight [Number, String] Sets a maximum height of a datatable - can be either a string ("10%") or a number of pixels.
maxWidth [Number, String] "100%" Sets a maximum width of a datatable - can be either a string ("10%") or a number of pixels.
mode String 'inline' Changes edit mode - available options: 'inline', 'modal'
multi Boolean false Allows selecting multiple rows (selectable mode)
newItemHeader String 'New item' A header of modal
noFoundMessage String "No matching results found" A message displayed when a table is empty
pagination Boolean true Shows/hides the pagination panel
rowsText String "Rows per page:" A text indicating a number of rows per page
saveText String 'Save Text displayed in the save button (modal)
search String Search phrase
searchColumns Array [] Columns to include while searching. All columns included for an empty array
selectable Boolean false Enables selecting rows with checkboxes
sm Boolean false Decreases a row's paddings
sortField String Default sorted column enabled by a field name
sortOrder String Default sorting order. Available values: "asc" or "desc".
striped Boolean false Slightly changes the background's color in every other row
tag String "div" Defines wrapper tag

Column properties

Name Type Default Description
editable Boolean true Enables/disabled editing fields in this column
label String '' A displayed header of a column
field String label.toLowerCase() A field's name - will be used as a key for values in rows
fixed [Boolean, String] false When set to true, makes a column stick on the left while scrolling. Changing its value to right will do the same on the other side. For this option to work, you need to define width as well.
inputType String 'text' Input type for a column. Available options: 'text', 'number', 'checkbox', 'select'
options Array [] Array of options (for column with a "select" input type)
width Number A column's width in pixels
sort Boolean true Enables/disables sorting for this column
format Array Cell formatting array of objects for each cell.

Methods

Name Description
addRow Adds a new row (default values are optional).
        
            
        <template>
          <div class="d-flex justify-content-end mb-4">
            <MDBInput
              v-model="basicSearch"
              label="Search"
              :disabled="basicEdit"
            />
            <MDBBtn
              color="primary"
              size="sm"
              class="ms-3"
              @click="basicEditorRef?.addRow()"
              :disabled="basicEdit"
            >
              <MDBIcon icon="plus"/>
            </MDBBtn>
          </div>
          <hr />
          <MDBTableEditor
            :search="basicSearch"
            :entries="5"
            :entriesOptions="[5, 10, 15]"
            v-model:edit="basicEdit"
            ref="basicEditorRef"
          >
            <table class="table">
              <thead>
                <tr>
                  <th class="th-sm" data-mdb-width="250">Company</th>
                  <th class="th-sm" data-mdb-width="250" data-mdb-sort="false">
                    Address
                  </th>
                  <th class="th-sm" data-mdb-width="250" data-mdb-sort="false">
                    Employees
                  </th>
                </tr>
              </thead>
              <tbody>
                <tr>
                  <td>Smith & Johnson</td>
                  <td>Park Lane 2, London</td>
                  <td>30</td>
                </tr>
                <tr>
                  <td>P.J. Company</td>
                  <td>Oak Street 7, Aberdeen</td>
                  <td>80</td>
                </tr>
                <tr>
                  <td>Food & Wine</td>
                  <td>Netherhall Gardens 3, Hampstead</td>
                  <td>12</td>
                </tr>
                <tr>
                  <td>IT Service</td>
                  <td>Warwick Road 14, London</td>
                  <td>17</td>
                </tr>
                <tr>
                  <td>A. Jonson Gallery</td>
                  <td>Oaklands Avenue 2, London</td>
                  <td>4</td>
                </tr>
                <tr>
                  <td>F.A. Architects</td>
                  <td>Frognal Way 7, Hampstead</td>
                  <td>4</td>
                </tr>
              </tbody>
            </table>
          </MDBTableEditor>
        </template>
        
        
    
        
            
        <script>
          import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
          import { MDBTableEditor } from "mdb-vue-table-editor";
          import { ref } from "vue";
          export default {
            components: {
              MDBInput, MDBBtn, MDBIcon, MDBTableEditor
            },
            setup() {
              const basicEditorRef = ref(null);
              const basicSearch = ref("");
              const basicEdit = ref(false);
        
              return {
                basicEditorRef,
                basicSearch,
                basicEdit,
              }
            }
          };
        </script>
        
        
    
        
            
        <script setup lang="ts">
          import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
          import { MDBTableEditor } from "mdb-vue-table-editor";
          import { ref } from "vue";
        
          const basicEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
          const basicSearch = ref("");
          const basicEdit = ref(false);
        </script>
        
        
    

Events

Name Description
add This event fires after adding a new row.
delete This event fires after deleting a row.
edit This event fires when user enters edit mode. Allows to get the current edited row via parameter.
exit This event fires when user exits edit mode.
render Event emitted after the component renders/updates rows.
update This event fires in an editable mode when a user updates values.
        
            
          <template>
            <MDBTableEditor @add="doSomething" >...</MDBTableEditor>
          </template>

Table editor

Angular Bootstrap 5 Table editor plugin

Table Editor is a useful tool for displaying and managing data. The component works similarly to the Datatable (docs) with an additional column for action buttons.

Responsive interactive built with Bootstrap 5, Angular and Material Design. Creates editable tables. Delete or edit rows directly or via modal editor.

Note: Examples use additional components such as Datatables, Modal, Alerts and Popconfirm. Remember to import them.


Basic example


Company Address Employees Actions
Smith & JohnsonPark Lane 2, London30
P.J. CompanyOak Street 7, Aberdeen80
Food & WineNetherhall Gardens 3, Hampstead12
IT ServiceWarwick Road 14, London17
A. Jonson GalleryOaklands Avenue 2, London4

Rows per page:

5
1 - 5 of 6
<div class="d-flex justify-content-end mb-4">
  <mdb-form-control>
    <input
      mdbInput
      type="text"
      class="form-control"
      id="search-input"
      [disabled]="addRow || editElementIndex !== -1"
      (keyup)="search($event)"
    />
    <label mdbLabel class="form-label" for="search-input">Search</label>
  </mdb-form-control>
  <button
    mdbRipple
    class="btn btn-primary btn-sm ms-3"
    [disabled]="addRow || editElementIndex !== -1"
    (click)="addRow = true"
  >
    <i class="fa fa-plus"></i>
  </button>
</div>
<hr />
<div
  class="datatable table-editor mt-4"
  [ngClass]="{ 'edited-table': addRow || editElementIndex !== -1 }"
>
  <table
    class="table datatable-table"
    mdbTable
    mdbTableSort
    #table="mdbTable"
    #sort="mdbTableSort"
    [dataSource]="dataSource"
    [sort]="sort"
    [pagination]="pagination"
  >
    <thead class="datatable-header">
      <tr>
        <th
          *ngFor="let header of headers"
          [mdbTableSortHeader]="header.field"
          [disableSort]="header.disableSort"
          scope="col"
        >
          {{ header.label | titlecase }}
        </th>
        <th scope="col">Actions</th>
      </tr>
    </thead>
    <tbody class="datatable-body">
      <tr
        *ngIf="addRow"
        [ngClass]="{ 'edited-row': addRow }"
        scope="row"
        cdkTrapFocus
        cdkTrapFocusAutoCapture="true"
      >
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="text"
              class="form-control"
              [(ngModel)]="newRow.company"
            />
          </mdb-form-control>
        </td>
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="text"
              class="form-control"
              [(ngModel)]="newRow.address"
            />
          </mdb-form-control>
        </td>
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="number"
              class="form-control"
              [(ngModel)]="newRow.employees"
            />
          </mdb-form-control>
        </td>
        <td>
          <button
            class="me-2 m-0 p-0 shadow-0 btn btn-lg save-button"
            (click)="addNewRow()"
          >
            <i class="fa fa-check"></i>
          </button>
          <button
            class="m-0 p-0 shadow-0 btn btn-lg discard-button"
            (click)="discardNewRow()"
          >
            <i class="fa fa-ban"></i>
          </button>
        </td>
      </tr>
      <tr
        *ngFor="let data of table.data; let index = index"
        scope="row"
        [cdkTrapFocus]="editElementIndex === index"
        [cdkTrapFocusAutoCapture]="editElementIndex === index"
        [ngClass]="{ 'edited-row': editElementIndex === index }"
      >
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.company }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="text"
                class="form-control"
                [(ngModel)]="data.company"
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.address }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="text"
                class="form-control"
                [(ngModel)]="data.address"
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.employees }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="number"
                class="form-control"
                [(ngModel)]="data.employees"
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td>
          <ng-container
            *ngIf="editElementIndex === -1 || editElementIndex !== index"
          >
            <button
              class="me-2 m-0 p-0 shadow-0 btn btn-lg edit-button"
              (click)="onEditClick(index)"
              [disabled]="
                addRow ||
                (editElementIndex !== -1 && editElementIndex !== index)
              "
            >
              <i class="far fa-edit"></i>
            </button>
            <button
              class="m-0 p-0 shadow-0 btn btn-lg delete-button"
              (click)="onDeleteClick(data)"
              [disabled]="
                addRow ||
                (editElementIndex !== -1 && editElementIndex !== index)
              "
            >
              <i class="far fa-trash-alt"></i>
            </button>
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <button
              class="me-2 m-0 p-0 shadow-0 btn btn-lg save-button"
              (click)="editElementIndex = -1"
            >
              <i class="fa fa-check"></i>
            </button>
            <button
              class="m-0 p-0 shadow-0 btn btn-lg discard-button"
              (click)="onDiscardEdit(index)"
            >
              <i class="fa fa-ban"></i>
            </button>
          </ng-container>
        </td>
      </tr>
    </tbody>
  </table>
  <mdb-table-pagination
    #pagination
    [entries]="5"
    [disabled]="addRow || editElementIndex !== -1"
  ></mdb-table-pagination>
</div>
import { Component, ViewChild } from '@angular/core';
import { MdbTableDirective } from 'mdb-angular-ui-kit/table';

export interface Person {
  company: string;
  address: string;
  employees: number | null;
}

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
})
export class AppComponent {
  @ViewChild('table') table!: MdbTableDirective<Person>;

  editElementIndex = -1;
  addRow = false;

  newRow: Person = {
    company: '',
    address: '',
    employees: null,
  };

  editRow: Person = {
    company: '',
    address: '',
    employees: null,
  };

  headers = [
    { label: 'Company', field: 'company', disableSort: false },
    { label: 'Address', field: 'address', disableSort: true },
    { label: 'Employees', field: 'employees', disableSort: true },
  ];

  dataSource: Person[] = [
    {
      company: 'Smith & Johnson',
      address: 'Park Lane 2, London',
      employees: 30,
    },
    {
      company: 'P.J. Company',
      address: 'Oak Street 7, Aberdeen',
      employees: 80,
    },
    {
      company: 'Food & Wine',
      address: 'Netherhall Gardens 3, Hampstead',
      employees: 12,
    },
    {
      company: 'IT Service',
      address: 'Warwick Road 14, London',
      employees: 17,
    },
    {
      company: 'A. Jonson Gallery',
      address: 'Oaklands Avenue 2, London',
      employees: 4,
    },
    {
      company: 'F.A. Architects',
      address: 'Frognal Way 7, Hampsteadn',
      employees: 4,
    },
  ];

  constructor() {}

  search(event: Event): void {
    const searchTerm = (event.target as HTMLInputElement).value;
    this.table.search(searchTerm);
  }

  addNewRow(): void {
    this.dataSource = [...this.dataSource, { ...this.newRow }];
    this.newRow.company = '';
    this.newRow.address = '';
    this.newRow.employees = null;
    this.addRow = false;
  }

  discardNewRow(): void {
    this.newRow.company = '';
    this.newRow.address = '';
    this.newRow.employees = null;
    this.addRow = false;
  }

  onEditClick(index: number): void {
    this.editElementIndex = index;
    this.editRow = { ...this.table.data[index] };
  }

  onDiscardEdit(index: number): void {
    this.editElementIndex = -1;
    this.table.data[index] = { ...this.editRow };
  }

  onDeleteClick(data: Person): void {
    const index = this.dataSource.indexOf(data);
    this.dataSource.splice(index, 1);
    this.dataSource = [...this.dataSource];
  }
}

Modal

Note: This example use Modal. Remember to import them.


Company Office Employees International Actions
Smith & JohnsonLondon30true
P.J. CompanyLondon80false
Food & WineLondon12false
IT ServiceLondon17false
A. Jonson GalleryLondon4false

Rows per page:

5
1 - 5 of 6
<div class="d-flex justify-content-end mb-4">
  <mdb-form-control>
    <input
      mdbInput
      type="text"
      class="form-control"
      id="search-input"
      (keyup)="search($event)"
    />
    <label mdbLabel class="form-label" for="search-input">Search</label>
  </mdb-form-control>
  <button
    mdbRipple
    class="btn btn-primary btn-sm ms-3"
    (click)="openModal('add')"
  >
    <i class="fa fa-plus"></i>
  </button>
</div>
<hr />
<div class="datatable table-editor mt-4">
  <table
    class="table datatable-table"
    mdbTable
    mdbTableSort
    #table="mdbTable"
    #sort="mdbTableSort"
    [dataSource]="dataSource"
    [sort]="sort"
    [pagination]="pagination"
  >
    <thead class="datatable-header">
      <tr>
        <th
          *ngFor="let header of headers"
          [mdbTableSortHeader]="header.field"
          [disableSort]="header.disableSort"
          scope="col"
        >
          {{ header.label | titlecase }}
        </th>
        <th scope="col">Actions</th>
      </tr>
    </thead>
    <tbody class="datatable-body">
      <tr *ngFor="let data of table.data; let index = index" scope="row">
        <td style="min-width: 250px; max-width: 250px">
          {{ data.company }}
        </td>
        <td style="min-width: 250px; max-width: 250px">
          {{ data.office }}
        </td>
        <td style="min-width: 250px; max-width: 250px">
          {{ data.employees }}
        </td>
        <td style="min-width: 100px; max-width: 100px">
          {{ data.international }}
        </td>

        <td>
          <button
            class="me-2 m-0 p-0 shadow-0 btn btn-lg edit-button"
            (click)="openModal('edit', data)"
          >
            <i class="far fa-edit"></i>
          </button>
          <button
            class="m-0 p-0 shadow-0 btn btn-lg delete-button"
            (click)="onDeleteClick(data)"
          >
            <i class="far fa-trash-alt"></i>
          </button>
        </td>
      </tr>
    </tbody>
  </table>
  <mdb-table-pagination #pagination [entries]="5"></mdb-table-pagination>
</div>
import { Component, ViewChild } from '@angular/core';
import { MdbModalRef, MdbModalService } from 'mdb-angular-ui-kit/modal';
import { MdbTableDirective } from 'mdb-angular-ui-kit/table';
import { ModalComponent } from './modal.component';

export interface Person {
  company: string;
  office: string;
  employees: number | null;
  international: boolean;
}

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
})
export class AppComponent {
  @ViewChild('table') table!: MdbTableDirective<Person>;

  modalRef: MdbModalRef<ModalComponent> | null = null;

  headers = [
    { label: 'Company', field: 'company', disableSort: false },
    { label: 'Office', field: 'office', disableSort: true },
    { label: 'Employees', field: 'employees', disableSort: false },
    { label: 'International', field: 'international', disableSort: false },
  ];

  dataSource: Person[] = [
    {
      company: 'Smith & Johnson',
      office: 'London',
      employees: 30,
      international: true,
    },
    {
      company: 'P.J. Company',
      office: 'London',
      employees: 80,
      international: false,
    },
    {
      company: 'Food & Wine',
      office: 'London',
      employees: 12,
      international: false,
    },
    {
      company: 'IT Service',
      office: 'London',
      employees: 17,
      international: false,
    },
    {
      company: 'A. Jonson Gallery',
      office: 'London',
      employees: 4,
      international: false,
    },
    {
      company: 'F.A. Architects',
      office: 'London',
      employees: 4,
      international: false,
    },
  ];

  constructor(private modalService: MdbModalService) {}

  search(event: Event): void {
    const searchTerm = (event.target as HTMLInputElement).value;
    this.table.search(searchTerm);
  }

  openModal(mode: 'add' | 'edit', data?: Person): void {
    this.modalRef = this.modalService.open(ModalComponent, {
      data: {
        modalTitle: mode === 'edit' ? 'Edit item' : 'New item',
        company: data ? data.company : '',
        office: data ? data.office : 'Warsaw',
        employees: data ? data.employees : 1,
        international: data ? data.international : false,
      },
      ignoreBackdropClick: true,
    });
    this.modalRef.onClose.subscribe((modalData: Person) => {
      if (!modalData) {
        return;
      }
      if (mode === 'add') {
        this.dataSource = [...this.dataSource, { ...modalData }];
      } else if (mode === 'edit' && data) {
        const index = this.dataSource.indexOf(data);
        this.dataSource[index] = modalData;
        this.dataSource = [...this.dataSource];
      }
    });
  }

  onDeleteClick(data: Person): void {
    const index = this.dataSource.indexOf(data);
    this.dataSource.splice(index, 1);
    this.dataSource = [...this.dataSource];
  }
}
<div class="modal-header">
  <h5 class="modal-title" id="exampleModalLabel">{{ modalTitle }}</h5>
</div>
<div class="modal-body">
  <div class="my-4 table-editor_input-wrapper">
    <mdb-form-control>
      <input
        mdbInput
        type="text"
        id="company-input"
        class="form-control"
        [(ngModel)]="company"
      />
      <label mdbLabel class="form-label" for="company-input">Company</label>
    </mdb-form-control>
  </div>
  <div class="my-4 table-editor_input-wrapper">
    <mdb-form-control>
      <mdb-select [(ngModel)]="office">
        <mdb-option *ngFor="let option of options" [value]="option.value">{{
          option.label
        }}</mdb-option>
      </mdb-select>
      <label mdbLabel class="form-label">Office</label>
    </mdb-form-control>
  </div>
  <div class="my-4 table-editor_input-wrapper">
    <mdb-form-control>
      <input
        mdbInput
        type="number"
        id="employees-input"
        class="form-control"
        [(ngModel)]="employees"
      />
      <label mdbLabel class="form-label" for="employees-input">Employees</label>
    </mdb-form-control>
  </div>
  <div class="my-4 table-editor_input-wrapper">
    <div class="form-check ms-1 mt-1">
      <input
        mdbCheckbox
        class="form-check-input"
        type="checkbox"
        value=""
        id="international-checkbox"
        [(ngModel)]="international"
      />
      <label class="form-check-label" for="flexCheckDefault">
        International
      </label>
    </div>
  </div>
</div>
<div class="modal-footer">
  <button
    type="button"
    class="shadow-0 btn btn-md btn-outline-primary"
    (click)="modalRef.close()"
  >
    Cancel
  </button>
  <button
    type="button"
    class="shadow-0 btn btn-md btn-primary"
    (click)="saveData()"
  >
    Save
  </button>
</div>
import { Component } from '@angular/core';
import { MdbModalRef } from 'mdb-angular-ui-kit/modal';

@Component({
  selector: 'app-modal',
  templateUrl: './modal.component.html',
})
export class ModalComponent {
  modalTitle: string | null = null;
  company: string | null = null;
  office: string | null = null;
  employees: string | null = null;
  international: string | null = null;

  options = [
    { value: 'London', label: 'London' },
    { value: 'Warsaw', label: 'Warsaw' },
    { value: 'New York', label: 'New York' },
  ];

  constructor(public modalRef: MdbModalRef<ModalComponent>) {}

  saveData(): void {
    const closeMessage = {
      company: this.company,
      office: this.office,
      employees: this.employees,
      international: this.international,
    };

    this.modalRef.close(closeMessage);
  }
}

Inputs example


Company Office Employees International Actions
Smith & JohnsonLondon30true
P.J. CompanyLondon80false
Food & WineLondon12false
IT ServiceLondon17false
A. Jonson GalleryLondon4false

Rows per page:

5
1 - 5 of 6
<div class="d-flex justify-content-end mb-4">
  <mdb-form-control>
    <input
      mdbInput
      type="text"
      class="form-control"
      id="search-input"
      [disabled]="addRow || editElementIndex !== -1"
      (keyup)="search($event)"
    />
    <label mdbLabel class="form-label" for="search-input">Search</label>
  </mdb-form-control>
  <button
    mdbRipple
    class="btn btn-primary btn-sm ms-3"
    [disabled]="addRow || editElementIndex !== -1"
    (click)="addRow = true"
  >
    <i class="fa fa-plus"></i>
  </button>
</div>
<hr />
<div
  class="datatable table-editor mt-4"
  [ngClass]="{
    'edited-table': addRow || editElementIndex !== -1
  }"
>
  <table
    class="table datatable-table"
    mdbTable
    mdbTableSort
    #table="mdbTable"
    #sort="mdbTableSort"
    [dataSource]="dataSource"
    [sort]="sort"
    [pagination]="pagination"
  >
    <thead class="datatable-header">
      <tr>
        <th
          *ngFor="let header of headers"
          [mdbTableSortHeader]="header.field"
          [disableSort]="header.disableSort"
          scope="col"
        >
          {{ header.label | titlecase }}
        </th>
        <th scope="col">Actions</th>
      </tr>
    </thead>
    <tbody class="datatable-body">
      <tr
        *ngIf="addRow"
        [ngClass]="{ 'edited-row': addRow }"
        scope="row"
        cdkTrapFocus
        cdkTrapFocusAutoCapture="true"
      >
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="text"
              class="form-control"
              [(ngModel)]="newRow.company"
            />
          </mdb-form-control>
        </td>
        <td>
          <mdb-form-control>
            <mdb-select [(ngModel)]="newRow.office">
              <mdb-option
                *ngFor="let option of options"
                [value]="option.value"
                >{{ option.label }}</mdb-option
              >
            </mdb-select>
          </mdb-form-control>
        </td>
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="number"
              class="form-control"
              [(ngModel)]="newRow.employees"
            />
          </mdb-form-control>
        </td>
        <td>
          <div class="form-check ms-1 mt-1">
            <input
              mdbCheckbox
              class="form-check-input"
              type="checkbox"
              [(ngModel)]="newRow.international"
            />
          </div>
        </td>
        <td>
          <button
            class="me-2 m-0 p-0 shadow-0 btn btn-lg save-button"
            (click)="addNewRow()"
          >
            <i class="fa fa-check"></i>
          </button>
          <button
            class="m-0 p-0 shadow-0 btn btn-lg discard-button"
            (click)="discardNewRow()"
          >
            <i class="fa fa-ban"></i>
          </button>
        </td>
      </tr>
      <tr
        *ngFor="let data of table.data; let index = index"
        scope="row"
        [cdkTrapFocus]="editElementIndex === index"
        [cdkTrapFocusAutoCapture]="editElementIndex === index"
        [ngClass]="{ 'edited-row': editElementIndex === index }"
      >
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.company }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="text"
                class="form-control"
                [(ngModel)]="data.company"
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.office }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <mdb-select [(ngModel)]="data.office">
                <mdb-option
                  *ngFor="let option of options"
                  [value]="option.value"
                  >{{ option.label }}</mdb-option
                >
              </mdb-select>
            </mdb-form-control>
          </ng-container>
        </td>
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.employees }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="number"
                class="form-control"
                [(ngModel)]="data.employees"
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td>
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.international }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <div class="form-check ms-1 mt-1">
              <input
                mdbCheckbox
                class="form-check-input"
                type="checkbox"
                [(ngModel)]="data.international"
              />
            </div>
          </ng-container>
        </td>
        <td>
          <ng-container
            *ngIf="editElementIndex === -1 || editElementIndex !== index"
          >
            <button
              class="me-2 m-0 p-0 shadow-0 btn btn-lg edit-button"
              (click)="onEditClick(index)"
              [disabled]="
                addRow ||
                (editElementIndex !== -1 && editElementIndex !== index)
              "
            >
              <i class="far fa-edit"></i>
            </button>
            <button
              class="m-0 p-0 shadow-0 btn btn-lg delete-button"
              (click)="onDeleteClick(data)"
              [disabled]="
                addRow ||
                (editElementIndex !== -1 && editElementIndex !== index)
              "
            >
              <i class="far fa-trash-alt"></i>
            </button>
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <button
              class="me-2 m-0 p-0 shadow-0 btn btn-lg save-button"
              (click)="editElementIndex = -1"
            >
              <i class="fa fa-check"></i>
            </button>
            <button
              class="m-0 p-0 shadow-0 btn btn-lg discard-button"
              (click)="onDiscardEdit(index)"
            >
              <i class="fa fa-ban"></i>
            </button>
          </ng-container>
        </td>
      </tr>
    </tbody>
  </table>
  <mdb-table-pagination
    #pagination
    [entries]="5"
    [disabled]="addRow || editElementIndex !== -1"
  ></mdb-table-pagination>
</div>
import { Component, ViewChild } from '@angular/core';
import { MdbTableDirective } from 'mdb-angular-ui-kit/table';

export interface Person {
  company: string;
  office: string;
  employees: number | null;
  international: boolean;
}

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
})
export class AppComponent {
  @ViewChild('table') table!: MdbTableDirective<Person>;

  editElementIndex = -1;
  addRow = false;

  newRow: Person = {
    company: '',
    office: 'Warsaw',
    employees: 1,
    international: false,
  };

  editRow: Person = {
    company: '',
    office: '',
    employees: null,
    international: false,
  };

  options = [
    { value: 'London', label: 'London' },
    { value: 'Warsaw', label: 'Warsaw' },
    { value: 'New York', label: 'New York' },
  ];

  headers = [
    { label: 'Company', field: 'company', disableSort: false },
    { label: 'Office', field: 'office', disableSort: true },
    { label: 'Employees', field: 'employees', disableSort: false },
    { label: 'International', field: 'international', disableSort: false },
  ];

  dataSource: Person[] = [
    {
      company: 'Smith & Johnson',
      office: 'London',
      employees: 30,
      international: true,
    },
    {
      company: 'P.J. Company',
      office: 'London',
      employees: 80,
      international: false,
    },
    {
      company: 'Food & Wine',
      office: 'London',
      employees: 12,
      international: false,
    },
    {
      company: 'IT Service',
      office: 'London',
      employees: 17,
      international: false,
    },
    {
      company: 'A. Jonson Gallery',
      office: 'London',
      employees: 4,
      international: false,
    },
    {
      company: 'F.A. Architects',
      office: 'London',
      employees: 4,
      international: false,
    },
  ];

  constructor() {}

  search(event: Event): void {
    const searchTerm = (event.target as HTMLInputElement).value;
    this.table.search(searchTerm);
  }

  addNewRow(): void {
    this.dataSource = [...this.dataSource, { ...this.newRow }];
    this.newRow.company = '';
    this.newRow.office = 'Warsaw';
    this.newRow.employees = 1;
    this.newRow.international = false;
    this.addRow = false;
  }

  discardNewRow(): void {
    this.newRow.company = '';
    this.newRow.office = 'Warsaw';
    this.newRow.employees = 1;
    this.newRow.international = false;
    this.addRow = false;
  }

  onEditClick(index: number): void {
    this.editElementIndex = index;
    this.editRow = { ...this.table.data[index] };
  }

  onDiscardEdit(index: number): void {
    this.editElementIndex = -1;
    this.table.data[index] = { ...this.editRow };
  }

  onDeleteClick(data: Person): void {
    const index = this.dataSource.indexOf(data);
    this.dataSource.splice(index, 1);
    this.dataSource = [...this.dataSource];
  }
}

Disable edit


Company Office Employees International Actions
Smith & JohnsonLondon30true
P.J. CompanyLondon80false
Food & WineLondon12false
IT ServiceLondon17false
A. Jonson GalleryLondon4false

Rows per page:

5
1 - 5 of 6
<div class="d-flex justify-content-end mb-4">
  <mdb-form-control>
    <input
      mdbInput
      type="text"
      class="form-control"
      id="search-input"
      [disabled]="addRow || editElementIndex !== -1"
      (keyup)="search($event)"
    />
    <label mdbLabel class="form-label" for="search-input">Search</label>
  </mdb-form-control>
  <button
    mdbRipple
    class="btn btn-primary btn-sm ms-3"
    [disabled]="addRow || editElementIndex !== -1"
    (click)="addRow = true"
  >
    <i class="fa fa-plus"></i>
  </button>
</div>
<hr />
<div
  class="datatable table-editor mt-4"
  [ngClass]="{
    'edited-table': addRow || editElementIndex !== -1
  }"
>
  <table
    class="table datatable-table"
    mdbTable
    mdbTableSort
    #table="mdbTable"
    #sort="mdbTableSort"
    [dataSource]="dataSource"
    [sort]="sort"
    [pagination]="pagination"
  >
    <thead class="datatable-header">
      <tr>
        <th
          *ngFor="let header of headers"
          [mdbTableSortHeader]="header.field"
          [disableSort]="header.disableSort"
          scope="col"
        >
          {{ header.label | titlecase }}
        </th>
        <th scope="col">Actions</th>
      </tr>
    </thead>
    <tbody class="datatable-body">
      <tr
        *ngIf="addRow"
        scope="row"
        cdkTrapFocus
        cdkTrapFocusAutoCapture="true"
        [ngClass]="{ 'edited-row': addRow }"
      >
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="text"
              class="form-control"
              [(ngModel)]="newRow.company"
              disabled
            />
          </mdb-form-control>
        </td>
        <td>
          <mdb-form-control>
            <mdb-select [(ngModel)]="newRow.office" disabled>
              <mdb-option
                *ngFor="let option of options"
                [value]="option.value"
                >{{ option.label }}</mdb-option
              >
            </mdb-select>
          </mdb-form-control>
        </td>
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="number"
              class="form-control"
              [(ngModel)]="newRow.employees"
              disabled
            />
          </mdb-form-control>
        </td>
        <td>
          <div class="form-check ms-1 mt-1">
            <input
              mdbCheckbox
              class="form-check-input"
              type="checkbox"
              [(ngModel)]="newRow.international"
              disabled
            />
          </div>
        </td>
        <td>
          <button
            class="me-2 m-0 p-0 shadow-0 btn btn-lg save-button"
            (click)="addNewRow()"
          >
            <i class="fa fa-check"></i>
          </button>
          <button
            class="m-0 p-0 shadow-0 btn btn-lg discard-button"
            (click)="discardNewRow()"
          >
            <i class="fa fa-ban"></i>
          </button>
        </td>
      </tr>
      <tr
        *ngFor="let data of table.data; let index = index"
        scope="row"
        [cdkTrapFocus]="editElementIndex === index"
        [cdkTrapFocusAutoCapture]="editElementIndex === index"
        [ngClass]="{
          'edited-row': editElementIndex === index
        }"
      >
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.company }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="text"
                class="form-control"
                [(ngModel)]="data.company"
                disabled
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.office }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <mdb-select [(ngModel)]="data.office" [disabled]="true">
                <mdb-option
                  *ngFor="let option of options"
                  [value]="option.value"
                  >{{ option.label }}</mdb-option
                >
              </mdb-select>
            </mdb-form-control>
          </ng-container>
        </td>
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.employees }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="number"
                class="form-control"
                [(ngModel)]="data.employees"
                disabled
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td>
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.international }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <div class="form-check ms-1 mt-1">
              <input
                mdbCheckbox
                class="form-check-input"
                type="checkbox"
                [(ngModel)]="data.international"
                disabled
              />
            </div>
          </ng-container>
        </td>
        <td>
          <ng-container
            *ngIf="editElementIndex === -1 || editElementIndex !== index"
          >
            <button
              class="me-2 m-0 p-0 shadow-0 btn btn-lg edit-button"
              (click)="editElementIndex = index"
              [disabled]="
                addRow ||
                (editElementIndex !== -1 && editElementIndex !== index)
              "
            >
              <i class="far fa-edit"></i>
            </button>
            <button
              class="m-0 p-0 shadow-0 btn btn-lg delete-button"
              (click)="onDeleteClick(data)"
              [disabled]="
                addRow ||
                (editElementIndex !== -1 && editElementIndex !== index)
              "
            >
              <i class="far fa-trash-alt"></i>
            </button>
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <button
              class="me-2 m-0 p-0 shadow-0 btn btn-lg save-button"
              (click)="editElementIndex = -1"
            >
              <i class="fa fa-check"></i>
            </button>
            <button
              class="m-0 p-0 shadow-0 btn btn-lg discard-button"
              (click)="editElementIndex = -1"
            >
              <i class="fa fa-ban"></i>
            </button>
          </ng-container>
        </td>
      </tr>
    </tbody>
  </table>
  <mdb-table-pagination
    #pagination
    [entries]="5"
    [disabled]="addRow || editElementIndex !== -1"
  ></mdb-table-pagination>
</div>
import { Component, ViewChild } from '@angular/core';
import { MdbTableDirective } from 'mdb-angular-ui-kit/table';

export interface Person {
  company: string;
  office: string;
  employees: number | null;
  international: boolean;
}

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
})
export class AppComponent {
  @ViewChild('table') table!: MdbTableDirective<Person>;

  editElementIndex = -1;
  addRow = false;

  newRow: Person = {
    company: '',
    office: 'Warsaw',
    employees: 1,
    international: false,
  };

  options = [
    { value: 'London', label: 'London' },
    { value: 'Warsaw', label: 'Warsaw' },
    { value: 'New York', label: 'New York' },
  ];

  headers = [
    { label: 'Company', field: 'company', disableSort: false },
    { label: 'Office', field: 'office', disableSort: true },
    { label: 'Employees', field: 'employees', disableSort: false },
    { label: 'International', field: 'international', disableSort: false },
  ];

  dataSource: Person[] = [
    {
      company: 'Smith & Johnson',
      office: 'London',
      employees: 30,
      international: true,
    },
    {
      company: 'P.J. Company',
      office: 'London',
      employees: 80,
      international: false,
    },
    {
      company: 'Food & Wine',
      office: 'London',
      employees: 12,
      international: false,
    },
    {
      company: 'IT Service',
      office: 'London',
      employees: 17,
      international: false,
    },
    {
      company: 'A. Jonson Gallery',
      office: 'London',
      employees: 4,
      international: false,
    },
    {
      company: 'F.A. Architects',
      office: 'London',
      employees: 4,
      international: false,
    },
  ];

  constructor() {}

  search(event: Event): void {
    const searchTerm = (event.target as HTMLInputElement).value;
    this.table.search(searchTerm);
  }

  addNewRow(): void {
    this.dataSource = [...this.dataSource, { ...this.newRow }];
    this.newRow.company = '';
    this.newRow.office = 'Warsaw';
    this.newRow.employees = 1;
    this.newRow.international = false;
    this.addRow = false;
  }

  discardNewRow(): void {
    this.newRow.company = '';
    this.newRow.office = 'Warsaw';
    this.newRow.employees = 1;
    this.newRow.international = false;
    this.addRow = false;
  }

  onDeleteClick(data: Person): void {
    const index = this.dataSource.indexOf(data);
    this.dataSource.splice(index, 1);
    this.dataSource = [...this.dataSource];
  }
}

Confirm delete

Note: This example use Popconfirm. Remember to import them.


Company Office Employees International Actions
Smith & JohnsonLondon30true
P.J. CompanyLondon80false
Food & WineLondon12false
IT ServiceLondon17false
A. Jonson GalleryLondon4false

Rows per page:

5
1 - 5 of 6
<div class="d-flex justify-content-end mb-4">
  <mdb-form-control>
    <input
      mdbInput
      type="text"
      class="form-control"
      id="search-input"
      [disabled]="addRow || editElementIndex !== -1"
      (keyup)="search($event)"
    />
    <label mdbLabel class="form-label" for="search-input">Search</label>
  </mdb-form-control>
  <button
    mdbRipple
    class="btn btn-primary btn-sm ms-3"
    [disabled]="addRow || editElementIndex !== -1"
    (click)="addRow = true"
  >
    <i class="fa fa-plus"></i>
  </button>
</div>
<hr />
<div
  class="datatable table-editor mt-4"
  [ngClass]="{
    'edited-table': addRow || editElementIndex !== -1
  }"
>
  <table
    class="table datatable-table"
    mdbTable
    mdbTableSort
    #table="mdbTable"
    #sort="mdbTableSort"
    [dataSource]="dataSource"
    [sort]="sort"
    [pagination]="pagination"
  >
    <thead class="datatable-header">
      <tr>
        <th
          *ngFor="let header of headers"
          [mdbTableSortHeader]="header.field"
          [disableSort]="header.disableSort"
          scope="col"
        >
          {{ header.label | titlecase }}
        </th>
        <th scope="col">Actions</th>
      </tr>
    </thead>
    <tbody class="datatable-body">
      <tr
        *ngIf="addRow"
        [ngClass]="{ 'edited-row': addRow }"
        scope="row"
        cdkTrapFocus
        cdkTrapFocusAutoCapture="true"
      >
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="text"
              class="form-control"
              [(ngModel)]="newRow.company"
            />
          </mdb-form-control>
        </td>
        <td>
          <mdb-form-control>
            <mdb-select [(ngModel)]="newRow.office">
              <mdb-option
                *ngFor="let option of options"
                [value]="option.value"
                >{{ option.label }}</mdb-option
              >
            </mdb-select>
          </mdb-form-control>
        </td>
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="number"
              class="form-control"
              [(ngModel)]="newRow.employees"
            />
          </mdb-form-control>
        </td>
        <td>
          <div class="form-check ms-1 mt-1">
            <input
              mdbCheckbox
              class="form-check-input"
              type="checkbox"
              [(ngModel)]="newRow.international"
            />
          </div>
        </td>
        <td>
          <button
            class="me-2 m-0 p-0 shadow-0 btn btn-lg save-button"
            (click)="addNewRow()"
          >
            <i class="fa fa-check"></i>
          </button>
          <button
            class="m-0 p-0 shadow-0 btn btn-lg discard-button"
            (click)="discardNewRow()"
          >
            <i class="fa fa-ban"></i>
          </button>
        </td>
      </tr>
      <tr
        *ngFor="let data of table.data; let index = index"
        scope="row"
        [cdkTrapFocus]="editElementIndex === index"
        [cdkTrapFocusAutoCapture]="editElementIndex === index"
        [ngClass]="{ 'edited-row': editElementIndex === index }"
      >
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.company }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="text"
                class="form-control"
                [(ngModel)]="data.company"
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.office }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <mdb-select [(ngModel)]="data.office">
                <mdb-option
                  *ngFor="let option of options"
                  [value]="option.value"
                  >{{ option.label }}</mdb-option
                >
              </mdb-select>
            </mdb-form-control>
          </ng-container>
        </td>
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.employees }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="number"
                class="form-control"
                [(ngModel)]="data.employees"
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td>
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.international }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <div class="form-check ms-1 mt-1">
              <input
                mdbCheckbox
                class="form-check-input"
                type="checkbox"
                [(ngModel)]="data.international"
              />
            </div>
          </ng-container>
        </td>
        <td>
          <ng-container
            *ngIf="editElementIndex === -1 || editElementIndex !== index"
          >
            <button
              class="me-2 m-0 p-0 shadow-0 btn btn-lg edit-button"
              (click)="onEditClick(index)"
              [disabled]="
                addRow ||
                (editElementIndex !== -1 && editElementIndex !== index)
              "
            >
              <i class="far fa-edit"></i>
            </button>
            <button
              class="m-0 p-0 shadow-0 btn btn-lg delete-button"
              #target
              (click)="openPopconfirm(target, data)"
              [disabled]="
                addRow ||
                (editElementIndex !== -1 && editElementIndex !== index)
              "
            >
              <i class="far fa-trash-alt"></i>
            </button>
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <button
              class="me-2 m-0 p-0 shadow-0 btn btn-lg save-button"
              (click)="editElementIndex = -1"
            >
              <i class="fa fa-check"></i>
            </button>
            <button
              class="m-0 p-0 shadow-0 btn btn-lg discard-button"
              (click)="onDiscardEdit(index)"
            >
              <i class="fa fa-ban"></i>
            </button>
          </ng-container>
        </td>
      </tr>
    </tbody>
  </table>
  <mdb-table-pagination
    #pagination
    [entries]="5"
    [disabled]="addRow || editElementIndex !== -1"
  ></mdb-table-pagination>
</div>
import { Component, ViewChild } from '@angular/core';
import {
  MdbPopconfirmRef,
  MdbPopconfirmService,
} from 'mdb-angular-ui-kit/popconfirm';
import { MdbTableDirective } from 'mdb-angular-ui-kit/table';
import { PopconfirmComponent } from './popconfirm.component';

export interface Person {
  company: string;
  office: string;
  employees: number | null;
  international: boolean;
}

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
})
export class AppComponent {
  @ViewChild('table') table!: MdbTableDirective<Person>;

  popconfirmRef: MdbPopconfirmRef<PopconfirmComponent> | null = null;
  editElementIndex = -1;
  addRow = false;

  newRow: Person = {
    company: '',
    office: 'Warsaw',
    employees: 1,
    international: false,
  };

  editRow: Person = {
    company: '',
    office: '',
    employees: null,
    international: false,
  };

  headers = [
    { label: 'Company', field: 'company', disableSort: false },
    { label: 'Office', field: 'office', disableSort: true },
    { label: 'Employees', field: 'employees', disableSort: false },
    { label: 'International', field: 'international', disableSort: false },
  ];

  options = [
    { value: 'London', label: 'London' },
    { value: 'Warsaw', label: 'Warsaw' },
    { value: 'New York', label: 'New York' },
  ];

  dataSource: Person[] = [
    {
      company: 'Smith & Johnson',
      office: 'London',
      employees: 30,
      international: true,
    },
    {
      company: 'P.J. Company',
      office: 'London',
      employees: 80,
      international: false,
    },
    {
      company: 'Food & Wine',
      office: 'London',
      employees: 12,
      international: false,
    },
    {
      company: 'IT Service',
      office: 'London',
      employees: 17,
      international: false,
    },
    {
      company: 'A. Jonson Gallery',
      office: 'London',
      employees: 4,
      international: false,
    },
    {
      company: 'F.A. Architects',
      office: 'London',
      employees: 4,
      international: false,
    },
  ];

  constructor(private popconfirmService: MdbPopconfirmService) {}

  search(event: Event): void {
    const searchTerm = (event.target as HTMLInputElement).value;
    this.table.search(searchTerm);
  }

  addNewRow() {
    this.dataSource = [...this.dataSource, { ...this.newRow }];
    this.newRow.company = '';
    this.newRow.office = 'Warsaw';
    this.newRow.employees = 1;
    this.newRow.international = false;
    this.addRow = false;
  }

  discardNewRow(): void {
    this.newRow.company = '';
    this.newRow.office = 'Warsaw';
    this.newRow.employees = 1;
    this.newRow.international = false;
    this.addRow = false;
  }

  onEditClick(index: number): void {
    this.editElementIndex = index;
    this.editRow = { ...this.table.data[index] };
  }

  onDiscardEdit(index: number): void {
    this.editElementIndex = -1;
    this.table.data[index] = { ...this.editRow };
  }

  onDeleteClick(data: Person): void {
    const index = this.dataSource.indexOf(data);
    this.dataSource.splice(index, 1);
    this.dataSource = [...this.dataSource];
  }

  openPopconfirm(target: HTMLElement, data: Person): void {
    this.popconfirmRef = this.popconfirmService.open(
      PopconfirmComponent,
      target,
      { data: { data: data } }
    );
    this.popconfirmRef.onClose.subscribe(() => {
      this.editElementIndex = -1;
    });
    this.popconfirmRef.onConfirm.subscribe((data) => {
      this.onDeleteClick(data);
    });
  }
}
<div class="popconfirm-popover shadow-4">
  <div class="popconfirm">
    <p class="popconfirm-message">
      <span class="popconfirm-message-text"
        >Are you sure you want to delete this entry?</span
      >
    </p>
    <div class="popconfirm-buttons-container">
      <button
        (click)="popconfirmRef.close()"
        type="button"
        aria-label="Cancel"
        class="btn btn-secondary btn-sm"
      >
        Cancel
      </button>
      <button
        (click)="popconfirmRef.confirm(data)"
        type="button"
        aria-label="Confirm"
        class="btn btn-primary btn-sm"
      >
        Delete
      </button>
    </div>
  </div>
</div>
import { Component, OnInit } from '@angular/core';
import { MdbPopconfirmRef } from 'mdb-angular-ui-kit/popconfirm';

@Component({
  selector: 'app-popconfirm',
  templateUrl: './popconfirm.component.html',
})
export class PopconfirmComponent implements OnInit {
  data: any = null;

  constructor(public popconfirmRef: MdbPopconfirmRef<PopconfirmComponent>) {}

  ngOnInit(): void {}
}


Async data


Company Email Name Phone Actions

Loading results...

Rows per page:

10
1 - 0 of 0
<div class="d-flex justify-content-between mb-4">
  <button class="btn btn-primary btn-sm" (click)="loadData()">Load data</button>
  <div class="d-flex">
    <mdb-form-control>
      <input
        mdbInput
        type="text"
        class="form-control"
        id="search-input"
        [disabled]="addRow || editElementIndex !== -1 || loading"
        (keyup)="search($event)"
      />
      <label mdbLabel class="form-label" for="search-input">Search</label>
    </mdb-form-control>
    <button
      mdbRipple
      class="btn btn-primary btn-sm ms-3"
      [disabled]="addRow || editElementIndex !== -1 || loading"
      (click)="addRow = true"
    >
      <i class="fa fa-plus"></i>
    </button>
  </div>
</div>
<hr />
<div
  class="datatable table-editor mt-4"
  [ngClass]="{
    'edited-table': addRow || editElementIndex !== -1
  }"
>
  <table
    class="table datatable-table"
    mdbTable
    mdbTableSort
    #table="mdbTable"
    #sort="mdbTableSort"
    [dataSource]="dataSource"
    [pagination]="pagination"
    [sort]="sort"
  >
    <thead class="datatable-header">
      <tr>
        <th
          *ngFor="let header of headers"
          [mdbTableSortHeader]="header.field"
          [disableSort]="header.disableSort"
          scope="col"
        >
          {{ header.label | titlecase }}
        </th>
        <th scope="col">Actions</th>
      </tr>
    </thead>
    <tbody class="datatable-body" *ngIf="!loading">
      <tr
        *ngIf="addRow"
        [ngClass]="{ 'edited-row': addRow }"
        scope="row"
        cdkTrapFocus
        cdkTrapFocusAutoCapture="true"
      >
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="text"
              class="form-control"
              [(ngModel)]="newRow.company"
            />
          </mdb-form-control>
        </td>
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="text"
              class="form-control"
              [(ngModel)]="newRow.email"
            />
          </mdb-form-control>
        </td>
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="text"
              class="form-control"
              [(ngModel)]="newRow.name"
            />
          </mdb-form-control>
        </td>
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="text"
              class="form-control"
              [(ngModel)]="newRow.phone"
            />
          </mdb-form-control>
        </td>
        <td>
          <button
            class="me-2 m-0 p-0 shadow-0 btn btn-lg save-button"
            (click)="addNewRow()"
          >
            <i class="fa fa-check"></i>
          </button>
          <button
            class="me-2 m-0 p-0 shadow-0 btn btn-lg discard-button"
            (click)="discardNewRow()"
          >
            <i class="fa fa-ban"></i>
          </button>
        </td>
      </tr>
      <tr
        *ngFor="let data of table.data; let index = index"
        scope="row"
        [cdkTrapFocus]="editElementIndex === index"
        [cdkTrapFocusAutoCapture]="editElementIndex === index"
        [ngClass]="{ 'edited-row': editElementIndex === index }"
      >
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.company }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="text"
                class="form-control"
                [(ngModel)]="data.company"
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.email }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="text"
                class="form-control"
                [(ngModel)]="data.email"
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.name }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="text"
                class="form-control"
                [(ngModel)]="data.name"
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td>
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.phone }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="text"
                class="form-control"
                [(ngModel)]="data.phone"
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td>
          <ng-container
            *ngIf="editElementIndex === -1 || editElementIndex !== index"
          >
            <button
              class="me-2 m-0 p-0 shadow-0 btn btn-lg edit-button"
              (click)="onEditClick(index)"
              [disabled]="editElementIndex !== -1 && editElementIndex !== index"
            >
              <i class="far fa-edit"></i>
            </button>
            <button
              class="m-0 p-0 shadow-0 btn btn-lg delete-button"
              (click)="onDeleteClick(data)"
              [disabled]="editElementIndex !== -1 && editElementIndex !== index"
            >
              <i class="far fa-trash-alt"></i>
            </button>
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <button
              class="me-2 m-0 p-0 shadow-0 btn btn-lg save-button"
              (click)="editElementIndex = -1"
            >
              <i class="fa fa-check"></i>
            </button>
            <button
              class="m-0 p-0 shadow-0 btn btn-lg discard-button"
              (click)="onDiscardEdit(index)"
            >
              <i class="fa fa-ban"></i>
            </button>
          </ng-container>
        </td>
      </tr>
    </tbody>
  </table>
  <ng-container *ngIf="loading">
    <div class="datatable-loader">
      <span class="datatable-loader-inner">
        <span class="datatable-progress bg-primary"></span>
      </span>
    </div>
    <p class="text-center text-muted my-4">Loading results...</p>
  </ng-container>
  <mdb-table-pagination
    #pagination
    [entries]="10"
    [disabled]="addRow || editElementIndex !== -1 || loading"
  ></mdb-table-pagination>
</div>
import { HttpClient } from '@angular/common/http';
import { Component, ViewChild } from '@angular/core';
import { MdbTableDirective } from 'mdb-angular-ui-kit/table';
import { tap, take } from 'rxjs/operators';

interface Person {
  company: string;
  email: string;
  name: string;
  phone: string;
}

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
})
export class AppComponent {
  @ViewChild('table') table!: MdbTableDirective<Person>;

  dataUrl = 'https://jsonplaceholder.typicode.com/users';
  loading = true;
  editElementIndex = -1;
  addRow = false;

  newRow: Person = {
    company: '',
    email: '',
    name: '',
    phone: '',
  };

  editRow: Person = {
    company: '',
    email: '',
    name: '',
    phone: '',
  };

  headers = [
    { label: 'Company', field: 'company', disableSort: false },
    { label: 'Email', field: 'email', disableSort: false },
    { label: 'Name', field: 'name', disableSort: false },
    { label: 'Phone', field: 'phone', disableSort: false },
  ];

  dataSource: Person[] = [];

  constructor(private _http: HttpClient) {}

  loadData() {
    this.getData()
      .pipe(take(1))
      .subscribe((data: any[]) => {
        const mappedData = data.map((entry) => {
          return { ...entry, company: entry.company.name };
        });
        this.dataSource = mappedData;
      });
  }

  getData() {
    return this._http
      .get<any>(this.dataUrl)
      .pipe(tap(() => (this.loading = false)));
  }

  search(event: Event): void {
    const searchTerm = (event.target as HTMLInputElement).value;
    this.table.search(searchTerm);
  }

  addNewRow(): void {
    this.dataSource = [...this.dataSource, { ...this.newRow }];
    this.newRow.company = '';
    this.newRow.email = '';
    this.newRow.name = '';
    this.newRow.phone = '';
    this.addRow = false;
  }

  discardNewRow(): void {
    this.newRow.company = '';
    this.newRow.email = '';
    this.newRow.name = '';
    this.newRow.phone = '';
    this.addRow = false;
  }

  onEditClick(index: number): void {
    this.editElementIndex = index;
    this.editRow.company = this.table.data[index].company;
    this.editRow.email = this.table.data[index].email;
    this.editRow.name = this.table.data[index].name;
    this.editRow.phone = this.table.data[index].phone;
  }

  onDiscardEdit(index: number): void {
    this.editElementIndex = -1;
    this.table.data[index].company = this.editRow.company;
    this.table.data[index].email = this.editRow.email;
    this.table.data[index].name = this.editRow.name;
    this.table.data[index].phone = this.editRow.phone;
  }

  onDeleteClick(data: Person): void {
    const index = this.dataSource.indexOf(data);
    this.dataSource.splice(index, 1);
    this.dataSource = [...this.dataSource];
  }
}

Custom rows

M.B.

(5 Avenue 26, New York)

Berkley & Clark

(43th Street 12, New York)

D&D Inc.

(14 Street 67, New York)

Thomas & Co.

(2 Avenue 54, New York)


Company Address City Actions
Smith & JohnsonPark Lane 2London
P.J. CompanyOak Street 7Aberdeen
Food & WineNetherhall Gardens 3Hampstead
IT ServiceWarwick Road 14London
A. Jonson GalleryOaklands Avenue 2London
F.A. ArchitectsFrognal Way 7Hampstead
<div class="row">
  <div class="col-md-3 col-sm-6 p-3">
    <h4>M.B.</h4>
    <p>(5 Avenue 26, New York)</p>
    <button
      class="btn btn-primary btn-sm"
      (click)="loadMB()"
      [disabled]="mBLoaded || addRow"
    >
      {{ mBLoaded ? "Loaded" : "Load into table" }}
    </button>
  </div>
  <div class="col-md-3 col-sm-6 p-3">
    <h4>Berkley & Clark</h4>
    <p>(43th Street 12, New York)</p>
    <button
      class="btn btn-primary btn-sm"
      (click)="loadBarkleyAndClark()"
      [disabled]="barkleyAndClarkLoaded || addRow"
    >
      {{ barkleyAndClarkLoaded ? "Loaded" : "Load into table" }}
    </button>
  </div>
  <div class="col-md-3 col-sm-6 p-3">
    <h4>D&D Inc.</h4>
    <p>(14 Street 67, New York)</p>
    <button
      class="btn btn-primary btn-sm"
      (click)="loadDAndDInc()"
      [disabled]="dAndDIncLoaded || addRow"
    >
      {{ dAndDIncLoaded ? "Loaded" : "Load into table" }}
    </button>
  </div>
  <div class="col-md-3 col-sm-6 p-3">
    <h4>Thomas & Co.</h4>
    <p>(2 Avenue 54, New York)</p>
    <button
      class="btn btn-primary btn-sm"
      (click)="loadThomasAndCo()"
      [disabled]="thomasAndCoLoaded || addRow"
    >
      {{ thomasAndCoLoaded ? "Loaded" : "Load into table" }}
    </button>
  </div>
</div>
<hr />
<div
  class="datatable table-editor mt-4"
  [ngClass]="{
    'edited-table': addRow || editElementIndex !== -1
  }"
>
  <table
    class="table datatable-table"
    mdbTable
    mdbTableSort
    #table="mdbTable"
    #sort="mdbTableSort"
    [dataSource]="dataSource"
    [sort]="sort"
  >
    <thead class="datatable-header">
      <tr>
        <th
          *ngFor="let header of headers"
          [mdbTableSortHeader]="header.field"
          [disableSort]="header.disableSort"
          scope="col"
        >
          {{ header.label | titlecase }}
        </th>
        <th scope="col">Actions</th>
      </tr>
    </thead>
    <tbody class="datatable-body">
      <tr
        *ngIf="addRow"
        [ngClass]="{ 'edited-row': addRow }"
        scope="row"
        cdkTrapFocus
        cdkTrapFocusAutoCapture="true"
      >
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="text"
              class="form-control"
              [(ngModel)]="newRow.company"
            />
          </mdb-form-control>
        </td>
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="text"
              class="form-control"
              [(ngModel)]="newRow.address"
            />
          </mdb-form-control>
        </td>
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="text"
              class="form-control"
              [(ngModel)]="newRow.city"
            />
          </mdb-form-control>
        </td>
        <td>
          <button
            class="me-2 m-0 p-0 shadow-0 btn btn-lg save-button"
            (click)="addNewRow()"
          >
            <i class="fa fa-check"></i>
          </button>
          <button
            class="m-0 p-0 shadow-0 btn btn-lg discard-button"
            (click)="discardNewRow()"
          >
            <i class="fa fa-ban"></i>
          </button>
        </td>
      </tr>
      <tr
        *ngFor="let data of table.data; let index = index"
        scope="row"
        [cdkTrapFocus]="editElementIndex === index"
        [cdkTrapFocusAutoCapture]="editElementIndex === index"
        [ngClass]="{ 'edited-row': editElementIndex === index }"
      >
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.company }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="text"
                class="form-control"
                [(ngModel)]="data.company"
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.address }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="text"
                class="form-control"
                [(ngModel)]="data.address"
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.city }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="text"
                class="form-control"
                [(ngModel)]="data.city"
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td>
          <ng-container
            *ngIf="editElementIndex === -1 || editElementIndex !== index"
          >
            <button
              class="me-2 m-0 p-0 shadow-0 btn btn-lg edit-button"
              (click)="onEditClick(index)"
              [disabled]="
                addRow ||
                (editElementIndex !== -1 && editElementIndex !== index)
              "
            >
              <i class="far fa-edit"></i>
            </button>
            <button
              class="m-0 p-0 shadow-0 btn btn-lg delete-button"
              (click)="onDeleteClick(data)"
              [disabled]="
                addRow ||
                (editElementIndex !== -1 && editElementIndex !== index)
              "
            >
              <i class="far fa-trash-alt"></i>
            </button>
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <button
              class="me-2 m-0 p-0 shadow-0 btn btn-lg save-button"
              (click)="editElementIndex = -1"
            >
              <i class="fa fa-check"></i>
            </button>
            <button
              class="m-0 p-0 shadow-0 btn btn-lg discard-button"
              (click)="onDiscardEdit(index)"
            >
              <i class="fa fa-ban"></i>
            </button>
          </ng-container>
        </td>
      </tr>
    </tbody>
  </table>
</div>
import { Component, ViewChild } from '@angular/core';
import { MdbTableDirective } from 'mdb-angular-ui-kit/table';

export interface Person {
  company: string;
  address: string;
  city: string;
}

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
})
export class AppComponent {
  @ViewChild('table') table!: MdbTableDirective<Person>;

  editElementIndex = -1;
  addRow = false;
  mBLoaded = false;
  barkleyAndClarkLoaded = false;
  dAndDIncLoaded = false;
  thomasAndCoLoaded = false;

  newRow: Person = {
    company: '',
    address: '',
    city: '',
  };

  editRow: Person = {
    company: '',
    address: '',
    city: '',
  };

  headers = [
    { label: 'Company', field: 'company', disableSort: false },
    { label: 'Address', field: 'address', disableSort: false },
    { label: 'City', field: 'city', disableSort: false },
  ];

  dataSource: Person[] = [
    { company: 'Smith & Johnson', address: 'Park Lane 2', city: 'London' },
    { company: 'P.J. Company', address: 'Oak Street 7', city: 'Aberdeen' },
    {
      company: 'Food & Wine',
      address: 'Netherhall Gardens 3',
      city: 'Hampstead',
    },
    { company: 'IT Service', address: 'Warwick Road 14', city: 'London' },
    {
      company: 'A. Jonson Gallery',
      address: 'Oaklands Avenue 2',
      city: 'London',
    },
    { company: 'F.A. Architects', address: 'Frognal Way 7', city: 'Hampstead' },
  ];
  constructor() {}

  search(event: Event): void {
    const searchTerm = (event.target as HTMLInputElement).value;
    this.table.search(searchTerm);
  }

  addNewRow(): void {
    this.dataSource = [...this.dataSource, { ...this.newRow }];
    this.newRow.company = '';
    this.newRow.address = '';
    this.newRow.city = 'null';
    this.addRow = false;
  }

  discardNewRow(): void {
    this.newRow.company = '';
    this.newRow.address = '';
    this.newRow.city = 'null';
    this.addRow = false;
  }

  onEditClick(index: number): void {
    this.editElementIndex = index;
    this.editRow = { ...this.table.data[index] };
  }

  onDiscardEdit(index: number): void {
    this.editElementIndex = -1;
    this.table.data[index] = { ...this.editRow };
  }

  onDeleteClick(data: Person) {
    const index = this.dataSource.indexOf(data);
    this.dataSource.splice(index, 1);
    this.dataSource = [...this.dataSource];
  }

  loadMB(): void {
    const row = {
      company: 'M.B.',
      address: '5 Avenue 26',
      city: 'New York',
    };
    this.mBLoaded = true;
    this.addRow = true;
    this.newRow = row;
  }

  loadBarkleyAndClark(): void {
    const row = {
      company: 'Berkley & Clark',
      address: '43th Street 12',
      city: 'New York',
    };
    this.barkleyAndClarkLoaded = true;
    this.addRow = true;
    this.newRow = row;
  }

  loadDAndDInc(): void {
    const row = {
      company: 'D&D Inc.',
      address: '14 Street 67',
      city: 'New York',
    };
    this.dAndDIncLoaded = true;
    this.addRow = true;
    this.newRow = row;
  }

  loadThomasAndCo(): void {
    const row = {
      company: 'Thomas & Co.',
      address: '2 Avenue 54',
      city: 'New York',
    };
    this.thomasAndCoLoaded = true;
    this.addRow = true;
    this.newRow = row;
  }
}

Notifications

Note: This example use Alerts Remember to import them.


Company Office Employees International Actions
Smith & JohnsonLondon30true
P.J. CompanyLondon80false
Food & WineLondon12false
IT ServiceLondon17false
A. Jonson GalleryLondon4false
F.A. ArchitectsLondon4false

Rows per page:

10
1 - 6 of 6
<div class="d-flex justify-content-end mb-4">
  <mdb-form-control>
    <input
      mdbInput
      type="text"
      class="form-control"
      id="search-input"
      [disabled]="addRow || editElementIndex !== -1"
      (keyup)="search($event)"
    />
    <label mdbLabel class="form-label" for="search-input">Search</label>
  </mdb-form-control>
  <button
    mdbRipple
    class="btn btn-primary btn-sm ms-3"
    [disabled]="editElementIndex !== -1"
    (click)="addRow = true"
  >
    <i class="fa fa-plus"></i>
  </button>
</div>
<hr />
<div
  class="datatable table-editor mt-4"
  [ngClass]="{
    'edited-table': addRow || editElementIndex !== -1
  }"
>
  <table
    class="table datatable-table"
    mdbTable
    mdbTableSort
    #table="mdbTable"
    #sort="mdbTableSort"
    [dataSource]="dataSource"
    [sort]="sort"
    [pagination]="pagination"
  >
    <thead class="datatable-header">
      <tr>
        <th
          *ngFor="let header of headers"
          [mdbTableSortHeader]="header.field"
          [disableSort]="header.disableSort"
          scope="col"
        >
          {{ header.label | titlecase }}
        </th>
        <th scope="col">Actions</th>
      </tr>
    </thead>
    <tbody class="datatable-body">
      <tr
        *ngIf="addRow"
        [ngClass]="{ 'edited-row': addRow }"
        scope="row"
        cdkTrapFocus
        cdkTrapFocusAutoCapture="true"
      >
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="text"
              class="form-control"
              [(ngModel)]="newRow.company"
            />
          </mdb-form-control>
        </td>
        <td>
          <mdb-form-control>
            <mdb-select [(ngModel)]="newRow.office">
              <mdb-option
                *ngFor="let option of options"
                [value]="option.value"
                >{{ option.label }}</mdb-option
              >
            </mdb-select>
          </mdb-form-control>
        </td>
        <td>
          <mdb-form-control>
            <input
              mdbInput
              type="number"
              class="form-control"
              [(ngModel)]="newRow.employees"
            />
          </mdb-form-control>
        </td>
        <td>
          <div class="form-check ms-1 mt-1">
            <input
              mdbCheckbox
              class="form-check-input"
              type="checkbox"
              [(ngModel)]="newRow.international"
            />
          </div>
        </td>
        <td>
          <button
            class="me-2 m-0 p-0 shadow-0 btn btn-lg save-button"
            (click)="addNewRow()"
          >
            <i class="fa fa-check"></i>
          </button>
          <button
            class="m-0 p-0 shadow-0 btn btn-lg discard-button"
            (click)="discardNewRow()"
          >
            <i class="fa fa-ban"></i>
          </button>
        </td>
      </tr>
      <tr
        *ngFor="let data of table.data; let index = index"
        scope="row"
        [cdkTrapFocus]="editElementIndex === index"
        [cdkTrapFocusAutoCapture]="editElementIndex === index"
        [ngClass]="{ 'edited-row': editElementIndex === index }"
      >
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.company }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="text"
                class="form-control"
                [(ngModel)]="data.company"
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.office }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <mdb-select [(ngModel)]="data.office">
                <mdb-option
                  *ngFor="let option of options"
                  [value]="option.value"
                  >{{ option.label }}</mdb-option
                >
              </mdb-select>
            </mdb-form-control>
          </ng-container>
        </td>
        <td style="min-width: 250px; max-width: 250px">
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.employees }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <mdb-form-control>
              <input
                mdbInput
                type="number"
                class="form-control"
                [(ngModel)]="data.employees"
              />
            </mdb-form-control>
          </ng-container>
        </td>
        <td>
          <ng-container *ngIf="editElementIndex !== index">
            {{ data.international }}
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <div class="form-check ms-1 mt-1">
              <input
                mdbCheckbox
                class="form-check-input"
                type="checkbox"
                [(ngModel)]="data.international"
              />
            </div>
          </ng-container>
        </td>
        <td>
          <ng-container
            *ngIf="editElementIndex === -1 || editElementIndex !== index"
          >
            <button
              class="me-2 m-0 p-0 shadow-0 btn btn-lg edit-button"
              (click)="onEditClick(index)"
              [disabled]="editElementIndex !== -1 && editElementIndex !== index"
            >
              <i class="far fa-edit"></i>
            </button>
            <button
              class="m-0 p-0 shadow-0 btn btn-lg delete-button"
              (click)="onDeleteClick(data)"
              [disabled]="editElementIndex !== -1 && editElementIndex !== index"
            >
              <i class="far fa-trash-alt"></i>
            </button>
          </ng-container>
          <ng-container *ngIf="editElementIndex === index">
            <button
              class="me-2 m-0 p-0 shadow-0 btn btn-lg save-button"
              (click)="onSaveClick(data)"
            >
              <i class="fa fa-check"></i>
            </button>
            <button
              class="m-0 p-0 shadow-0 btn btn-lg discard-button"
              (click)="onDiscardEdit(index)"
            >
              <i class="fa fa-ban"></i>
            </button>
          </ng-container>
        </td>
      </tr>
    </tbody>
  </table>
  <mdb-table-pagination
    #pagination
    [entries]="5"
    [disabled]="addRow || editElementIndex !== -1"
  ></mdb-table-pagination>
</div>
import { Component, ViewChild } from '@angular/core';
import {
  MdbNotificationService,
  MdbNotificationRef,
} from 'mdb-angular-ui-kit/notification';
import { MdbTableDirective } from 'mdb-angular-ui-kit/table';
import { NotificationComponent } from './notification.component';

export interface Person {
  company: string;
  office: string;
  employees: number | null;
  international: boolean;
}

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
})
export class AppComponent {
  @ViewChild('table') table!: MdbTableDirective<Person>;

  notificationRef: MdbNotificationRef<NotificationComponent> | null = null;
  editElementIndex = -1;
  addRow = false;

  newRow: Person = {
    company: '',
    office: 'Warsaw',
    employees: 1,
    international: false,
  };

  editRow: Person = {
    company: '',
    office: '',
    employees: null,
    international: false,
  };

  options = [
    { value: 'London', label: 'London' },
    { value: 'Warsaw', label: 'Warsaw' },
    { value: 'New York', label: 'New York' },
  ];

  headers = [
    { label: 'Company', field: 'company', disableSort: false },
    { label: 'Office', field: 'office', disableSort: true },
    { label: 'Employees', field: 'employees', disableSort: false },
    { label: 'International', field: 'international', disableSort: false },
  ];

  dataSource: Person[] = [
    {
      company: 'Smith & Johnson',
      office: 'London',
      employees: 30,
      international: true,
    },
    {
      company: 'P.J. Company',
      office: 'London',
      employees: 80,
      international: false,
    },
    {
      company: 'Food & Wine',
      office: 'London',
      employees: 12,
      international: false,
    },
    {
      company: 'IT Service',
      office: 'London',
      employees: 17,
      international: false,
    },
    {
      company: 'A. Jonson Gallery',
      office: 'London',
      employees: 4,
      international: false,
    },
    {
      company: 'F.A. Architects',
      office: 'London',
      employees: 4,
      international: false,
    },
  ];

  constructor(private notificationService: MdbNotificationService) {}

  search(event: Event): void {
    const searchTerm = (event.target as HTMLInputElement).value;
    this.table.search(searchTerm);
  }

  addNewRow(): void {
    this.dataSource = [...this.dataSource, { ...this.newRow }];
    this.openAlert(this.newRow, 'add');
    this.newRow.company = '';
    this.newRow.office = 'Warsaw';
    this.newRow.employees = 1;
    this.newRow.international = false;
    this.addRow = false;
  }

  discardNewRow(): void {
    this.newRow.company = '';
    this.newRow.office = 'Warsaw';
    this.newRow.employees = 1;
    this.addRow = false;
  }

  onEditClick(index: number): void {
    this.editElementIndex = index;
    this.editRow = { ...this.table.data[index] };
  }

  onDiscardEdit(index: number): void {
    this.editElementIndex = -1;
    this.table.data[index] = { ...this.editRow };
  }

  onDeleteClick(data: Person): void {
    const index = this.dataSource.indexOf(data);
    this.dataSource.splice(index, 1);
    this.dataSource = [...this.dataSource];
    this.openAlert(data, 'delete');
  }

  onSaveClick(data: Person): void {
    this.editElementIndex = -1;
    this.openAlert(data, 'edit');
  }

  openAlert(data: Person, action: 'add' | 'delete' | 'edit'): void {
    const options = {
      action: action,
      rowData: `${data.company} (${data.office})`,
    };
    this.notificationRef = this.notificationService.open(
      NotificationComponent,
      { data: options, autohide: true, delay: 1000 }
    );
  }
}
<div class="alert alert-{{ color }}" role="alert">
  <strong>{{ actionText }}</strong> {{ rowData }}
</div>
import { Component, OnInit } from '@angular/core';
import { MdbNotificationRef } from 'mdb-angular-ui-kit/notification';

@Component({
  selector: 'app-notification',
  templateUrl: './notification.component.html',
})
export class NotificationComponent implements OnInit {
  action: 'add' | 'delete' | 'edit' | null = null;
  rowData: string | null = null;
  color: string | null = null;
  actionText: string | null = null;

  constructor(
    public notificationRef: MdbNotificationRef<NotificationComponent>
  ) {}

  ngOnInit(): void {
    switch (this.action) {
      case 'add':
        this.color = 'success';
        this.actionText = 'New entry:';
        break;
      case 'delete':
        this.color = 'danger';
        this.actionText = 'Deleted entry:';
        break;
      case 'edit':
        this.color = 'primary';
        this.actionText = 'Updated entry:';
        break;
      default:
        break;
    }
  }
}

Table editor - API


Import

import { MdbTableModule } from 'mdb-angular-ui-kit/table';
import { MdbFormsModule } from 'mdb-angular-ui-kit/forms';
import { FormsModule } from '@angular/forms';
import { A11yModule } from '@angular/cdk/a11y';
import { MdbSelectModule } from 'mdb-angular-ui-kit/select';              // For examples with Select
import { MdbModalModule } from 'mdb-angular-ui-kit/modal';                // For examples with Modal
import { MdbNotificationModule } from 'mdb-angular-ui-kit/notification';  // For examples with Notification
import { MdbPopconfirmModule } from 'mdb-angular-ui-kit/popconfirm';      // For examples with Popconfirm

...
@NgModule({
  ...
  imports: [
    MdbTableModule,
    MdbFormsModule,
    FormsModule,
    A11yModule,
    MdbSelectModule,        // For examples with Select
    MdbModalModule,         // For examples with Modal
    MdbNotificationModule,  // For examples with Notification
    MdbPopconfirmModule     // For examples with Popconfirm
  ],
  ...
})

Table editor

React Bootstrap 5 Table editor plugin

Table Editor is a useful tool for displaying and managing data. The component works similarly to the React Datatable (docs) with an additional column for action buttons.

Responsive interactive built with the latest Bootstrap 5. Creates editable tables. Delete or edit rows directly or via modal editor.

Note: Read the API tab to find all available options and advanced customization


Basic example

You can initialize the component with MDBTableEditor.


Company Address Employees
Smith & Johnson Park Lane 2, London 30
P.J. Company Oak Street 7, Aberdeen 80
Food & Wine Netherhall Gardens 3, Hampstead 12
IT Service Warwick Road 14, London 17
A. Jonson Gallery Oaklands Avenue 2, London 4
F.A. Architects Frognal Way 7, Hampstead 4
import React, { useState } from 'react';
import { MDBTableEditor } from 'mdb-react-table-editor';

export default function App() {
  const basicColumns = [
    {
      width: 250,
      label: 'Company',
      field: 'company',
    },
    {
      width: 250,
      label: 'Address',
      field: 'address',
      sort: false,
    },
    {
      width: 250,
      label: 'Employees',
      field: 'employees',
      sort: false,
    },
  ];

  const basicRows = [
    {
      company: 'Smith & Johnson',
      address: 'Park Lane 2, London',
      employees: 30,
    },
    {
      company: 'P.J. Company',
      address: 'Oak Street 7, Aberdeen',
      employees: 80,
    },
    {
      company: 'Food & Wine',
      address: 'Netherhall Gardens 3, Hampstead',
      employees: 12,
    },
    {
      company: 'IT Service',
      address: 'Warwick Road 14, London',
      employees: 17,
    },
    {
      company: 'A. Jonson Gallery',
      address: 'Oaklands Avenue 2, London',
      employees: 4,
    },
    {
      company: 'F.A. Architects',
      address: 'Frognal Way 7, Hampstead',
      employees: 4,
    },
  ];

  const [basicData, setBasicData] = useState({
    columns: basicColumns,
    rows: basicRows,
  });

  return (
    <MDBTableEditor
      onAdd={(newRow) => setBasicData({ ...basicData, rows: [...basicData.rows, newRow] })}
      onModify={(modifiedData) => setBasicData({ ...basicData, rows: modifiedData })}
      onDelete={(id) => setBasicData({ ...basicData, rows: basicData.rows.filter((row, i) => i !== id) })}
      entries={5}
      data={basicData}
      entriesOptions={[5, 10, 15]}
    />
  );
}

Modal

To change the default editing mode (inline) to the modal version, set property modal to true.

import React, { useState } from 'react';
import { MDBTableEditor } from 'mdb-react-table-editor';

export default function App() {
  const advancedColumns = [
    {
      width: 250,
      label: 'Company',
      field: 'company',
    },
    {
      width: 250,
      sort: false,
      defaultValue: 'Warsaw',
      options: ['London', 'Warsaw', 'New York'],
      inputType: 'select',
      label: 'Office',
      field: 'office',
    },
    {
      width: 250,
      inputType: 'number',
      defaultValue: 1,
      label: 'Employees',
      field: 'employees',
    },
    {
      width: 100,
      defaultValue: false,
      inputType: 'checkbox',
      label: 'International',
      field: 'international',
    },
  ];

  const advancedRows = [
    {
      company: 'Smith & Johnson',
      office: 'London',
      employees: 30,
      international: true,
    },
    {
      company: 'P.J. Company',
      office: 'London',
      employees: 80,
      international: false,
    },
    {
      company: 'Food & Wine',
      office: 'London',
      employees: 12,
      international: false,
    },
    {
      company: 'IT Service',
      office: 'London',
      employees: 17,
      international: false,
    },
    {
      company: 'A. Jonson Gallery',
      office: 'London',
      employees: 4,
      international: false,
    },
    {
      company: 'F.A. Architects',
      office: 'London',
      employees: 4,
      international: false,
    },
  ];

  const [modalData, setModalData] = useState({
    columns: advancedColumns,
    rows: advancedRows,
  });

  return (
    <MDBTableEditor
      mode='modal'
      data={modalData}
      entriesOptions={[5, 10, 15]}
      entries={5}
      onAdd={(newRow) => setModalData({ ...modalData, rows: [...modalData.rows, newRow] })}
      onModify={(modifiedData) => setModalData({ ...modalData, rows: modifiedData })}
      onDelete={(id) => setModalData({ ...modalData, rows: modalData.rows.filter((row, i) => i !== id) })}
    />
  );
}

Inputs example

Table Editor supports several input types - for example, if you wish to force a user to enter only Boolean values in one column, you can set its inputType to a checkbox.

Supported input types:

  • Text (default)
  • Number
  • Checkbox - displays a checkbox in edit mode and true/false value otherwise
  • Select - additionally requires an array of options
import React, { useState } from 'react';
import { MDBTableEditor } from 'mdb-react-table-editor';

export default function App() {
  const advancedColumns = [
    {
      width: 250,
      label: 'Company',
      field: 'company',
    },
    {
      width: 250,
      sort: false,
      defaultValue: 'Warsaw',
      options: ['London', 'Warsaw', 'New York'],
      inputType: 'select',
      label: 'Office',
      field: 'office',
    },
    {
      width: 250,
      inputType: 'number',
      defaultValue: 1,
      label: 'Employees',
      field: 'employees',
    },
    {
      width: 100,
      defaultValue: false,
      inputType: 'checkbox',
      label: 'International',
      field: 'international',
    },
  ];

  const advancedRows = [
    {
      company: 'Smith & Johnson',
      office: 'London',
      employees: 30,
      international: true,
    },
    {
      company: 'P.J. Company',
      office: 'London',
      employees: 80,
      international: false,
    },
    {
      company: 'Food & Wine',
      office: 'London',
      employees: 12,
      international: false,
    },
    {
      company: 'IT Service',
      office: 'London',
      employees: 17,
      international: false,
    },
    {
      company: 'A. Jonson Gallery',
      office: 'London',
      employees: 4,
      international: false,
    },
    {
      company: 'F.A. Architects',
      office: 'London',
      employees: 4,
      international: false,
    },
  ];

  const [basicData, setBasicData] = useState({
    columns: advancedColumns,
    rows: advancedRows,
  });


  return (
    <MDBTableEditor
      onAdd={(newRow) => setBasicData({ ...basicData, rows: [...basicData.rows, newRow] })}
      onModify={(modifiedData) => setBasicData({ ...basicData, rows: modifiedData })}
      onDelete={(id) => setBasicData({ ...basicData, rows: basicData.rows.filter((row, i) => i !== id) })}
      entries={5}
      data={basicData}
      entriesOptions={[5, 10, 15]}
    />
  );
}

Disable edit

You can disable editing for a table by setting its editable property to false. A user won't be able to change its value in the edit mode.

import React, { useState } from 'react';
import { MDBTableEditor } from 'mdb-react-table-editor';

export default function App() {
  const advancedColumns = [
    {
      width: 250,
      label: 'Company',
      field: 'company',
    },
    {
      width: 250,
      sort: false,
      defaultValue: 'Warsaw',
      options: ['London', 'Warsaw', 'New York'],
      inputType: 'select',
      label: 'Office',
      field: 'office',
    },
    {
      width: 250,
      inputType: 'number',
      defaultValue: 1,
      label: 'Employees',
      field: 'employees',
    },
    {
      width: 100,
      defaultValue: false,
      inputType: 'checkbox',
      label: 'International',
      field: 'international',
    },
  ];

  const advancedRows = [
    {
      company: 'Smith & Johnson',
      office: 'London',
      employees: 30,
      international: true,
    },
    {
      company: 'P.J. Company',
      office: 'London',
      employees: 80,
      international: false,
    },
    {
      company: 'Food & Wine',
      office: 'London',
      employees: 12,
      international: false,
    },
    {
      company: 'IT Service',
      office: 'London',
      employees: 17,
      international: false,
    },
    {
      company: 'A. Jonson Gallery',
      office: 'London',
      employees: 4,
      international: false,
    },
    {
      company: 'F.A. Architects',
      office: 'London',
      employees: 4,
      international: false,
    },
  ];

  const [disableData, setDisableData] = useState({
    columns: advancedColumns,
    rows: advancedRows,
  });

  return (
    <MDBTableEditor
      editable={false}
      onAdd={(newRow) => setDisableData({ ...disableData, rows: [...disableData.rows, newRow] })}
      onModify={(modifiedData) => setDisableData({ ...disableData, rows: modifiedData })}
      onDelete={(id) => setDisableData({ ...disableData, rows: disableData.rows.filter((row, i) => i !== id) })}
      entries={5}
      data={disableData}
      entriesOptions={[5, 10, 15]}
    />
  );
}

Confirm delete

If you want to prevent data from being accidentally removed, you can set a confirm option to true. In this case, Table Editor will show a Popconfirm element before removing an entry.

import React, { useState } from 'react';
import { MDBTableEditor } from 'mdb-react-table-editor';

export default function App() {
  const advancedColumns = [
    {
      width: 250,
      label: 'Company',
      field: 'company',
    },
    {
      width: 250,
      sort: false,
      defaultValue: 'Warsaw',
      options: ['London', 'Warsaw', 'New York'],
      inputType: 'select',
      label: 'Office',
      field: 'office',
    },
    {
      width: 250,
      inputType: 'number',
      defaultValue: 1,
      label: 'Employees',
      field: 'employees',
    },
    {
      width: 100,
      defaultValue: false,
      inputType: 'checkbox',
      label: 'International',
      field: 'international',
    },
  ];

  const advancedRows = [
    {
      company: 'Smith & Johnson',
      office: 'London',
      employees: 30,
      international: true,
    },
    {
      company: 'P.J. Company',
      office: 'London',
      employees: 80,
      international: false,
    },
    {
      company: 'Food & Wine',
      office: 'London',
      employees: 12,
      international: false,
    },
    {
      company: 'IT Service',
      office: 'London',
      employees: 17,
      international: false,
    },
    {
      company: 'A. Jonson Gallery',
      office: 'London',
      employees: 4,
      international: false,
    },
    {
      company: 'F.A. Architects',
      office: 'London',
      employees: 4,
      international: false,
    },
  ];

  const [confirmData, setConfirmData] = useState({
    columns: advancedColumns,
    rows: advancedRows,
  });

  return (
    <MDBTableEditor
      confirmDelete
      data={confirmData}
      entriesOptions={[5, 10, 15]}
      entries={5}
      onAdd={(newRow) => setConfirmData({ ...confirmData, rows: [...confirmData.rows, newRow] })}
      onModify={(modifiedData) => setConfirmData({ ...confirmData, rows: modifiedData })}
      onDelete={(id) => setConfirmData({ ...confirmData, rows: confirmData.rows.filter((row, i) => i !== id) })}
    />
  );
}


Async data

While awaiting data from API, you can prevent a user from interacting with Table Editor by managing loading property.


import React, { useState, useEffect } from 'react';
import { MDBTableEditor } from 'mdb-react-table-editor';
import { MDBBtn, MDBIcon } from 'mdb-react-ui-kit';

export default function App() {
  const [loading, setLoading] = useState(false);

  const [asyncData, setAsyncData] = useState({
    columns: [
      { label: 'Company', field: 'company' },
      { label: 'Email', field: 'email' },
      { label: 'Name', field: 'name' },
      { label: 'Phone', field: 'phone' },
    ],
    rows: [],
  });

  useEffect(() => {
    if (loading) {
      fetch('https://jsonplaceholder.typicode.com/users')
        .then((response) => response.json())
        .then((data) =>
          setTimeout(() => {
            setAsyncData({
              columns: asyncData.columns,
              rows: data.map((user: any) => ({
                ...user,
                address: `${user.address.city}, ${user.address.street}`,
                company: user.company.name,
              })),
            });
          }, 3000)
        );
    }
  }, [loading, asyncData.columns]);

  useEffect(() => {
    if (asyncData.rows.length === 0) {
      setLoading(true);
    } else {
      setLoading(false);
    }
  }, [asyncData.rows]);

  return (
    <>
      <MDBBtn className='mb-4' onClick={() => setAsyncData({ ...asyncData, rows: [] })}>
        Reload data
        <MDBIcon icon='sync' className='ms-2' />
      </MDBBtn>

      <MDBTableEditor
        isLoading={loading}
        data={asyncData}
        entriesOptions={[5, 10, 15]}
        entries={5}
        onAdd={(newRow) => setAsyncData({ ...asyncData, rows: [...asyncData.rows, newRow] })}
        onModify={(modifiedData) => setAsyncData({ ...asyncData, rows: modifiedData })}
        onDelete={(id) => setAsyncData({ ...asyncData, rows: asyncData.rows.filter((row, i) => i !== id) })}
      />
    </>
  );
}

Custom rows

The add() method takes an optional argument - a row which values will be preloaded into a new entry.

Note: for this particular use, a row has to be an object.

Note: as adding buttons are initialized manually, they won't be automatically disabled in the edit mode.

M.B.

(5 Avenue 26, New York)

Berkley & Clark

(43th Street 12, New York)

D&D Inc.

(14 Street 67, New York)

Thomas & Co.

(2 Avenue 54, New York)


import React, { useState } from 'react';
import { MDBTableEditor } from 'mdb-react-table-editor';
import { MDBBtn, MDBRow, MDBCol } from 'mdb-react-ui-kit';

export default function App() {
  const basicColumns: AdvancedHeader[] = [
    {
      width: 250,
      label: 'Company',
      field: 'company',
    },
    {
      width: 250,
      label: 'Address',
      field: 'address',
    },
    {
      width: 250,
      label: 'City',
      field: 'city',
    },
  ];

  const basicRows: AdvancedRecord[] = [
    { company: 'Smith & Johnson', address: 'Park Lane 2', city: 'London' },
    { company: 'P.J. Company', address: 'Oak Street 7', city: 'Aberdeen' },
    { company: 'Food & Wine', address: 'Netherhall Gardens 3', city: 'Hampstead' },
    { company: 'IT Service', address: 'Warwick Road 14', city: 'London' },
    { company: 'A. Jonson Gallery', address: 'Oaklands Avenue 2', city: 'London' },
    { company: 'F.A. Architects', address: 'Frognal Way 7', city: 'Hampstead' },
  ];

  const [customRows, setCustomRows] = useState({
    columns: basicColumns,
    rows: basicRows,
  });

  const [customLoaded, setCustomLoaded] = useState({
    row1: false,
    row2: false,
    row3: false,
    row4: false,
  });

  const { row1, row2, row3, row4 } = customLoaded;

  const loadCustom = (row: AdvancedRecord, name: string) => {
    setCustomRows({ ...customRows, rows: [...customRows.rows, row] });

    setCustomLoaded({ ...customLoaded, [name]: true });
  };

  return (
    <>
      <MDBRow>
        <MDBCol md='3' sm='6' className='p-3'>
          <h4>M.B.</h4>
          <p>(5 Avenue 26, New York)</p>

          <MDBBtn
            onClick={() =>
              loadCustom(
                {
                  company: 'M.B.',
                  address: '5 Avenue 26',
                  city: 'New York',
                },
                'row1'
              )
            }
            disabled={row1}
            size='sm'
            className='add-entry-button'
          >
            {row1 ? 'Loaded' : 'Load into table'}
          </MDBBtn>
        </MDBCol>
        <MDBCol md='3' sm='6' className='p-3'>
          <h4>Berkley &amp; Clark</h4>
          <p>(43th Street 12, New York)</p>

          <MDBBtn
            onClick={() =>
              loadCustom(
                {
                  company: 'Berkley & Clark.',
                  address: '43th Street 12',
                  city: 'New York',
                },
                'row2'
              )
            }
            disabled={row2}
            size='sm'
            className='add-entry-button'
          >
            {row2 ? 'Loaded' : 'Load into table'}
          </MDBBtn>
        </MDBCol>
        <MDBCol md='3' sm='6' className='p-3'>
          <h4>D&amp;D Inc.</h4>
          <p>(14 Street 67, New York)</p>

          <MDBBtn
            onClick={() =>
              loadCustom(
                {
                  company: 'D&D Inc.',
                  address: '14 Street 67',
                  city: 'New York',
                },
                'row3'
              )
            }
            disabled={row3}
            size='sm'
            className='add-entry-button'
          >
            {row3 ? 'Loaded' : 'Load into table'}
          </MDBBtn>
        </MDBCol>
        <MDBCol md='3' sm='6' className='p-3'>
          <h4>Thomas &amp; Co.</h4>
          <p>(2 Avenue 54, New York)</p>

          <MDBBtn
            onClick={() =>
              loadCustom(
                {
                  company: 'Thomas & Co.',
                  address: '2 Avenue 54',
                  city: 'New York',
                },
                'row4'
              )
            }
            disabled={row4}
            size='sm'
            className='add-entry-button'
          >
            {row4 ? 'Loaded' : 'Load into table'}
          </MDBBtn>
        </MDBCol>
      </MDBRow>

      <MDBTableEditor
        search={false}
        data={customRows}
        entriesOptions={[5, 10, 15]}
        entries={5}
        onAdd={(newRow) => setCustomRows({ ...customRows, rows: [...customRows.rows, newRow] })}
        onModify={(modifiedData) => setCustomRows({ ...customRows, rows: modifiedData })}
        onDelete={(id) => setCustomRows({ ...customRows, rows: customRows.rows.filter((row, i) => i !== id) })}
      />
    </>
  );
}

Notifications

In this example, handlers for custom events trigger notifications after adding/deleting/updating an entry.

import React, { useState } from 'react';
import { MDBTableEditor } from 'mdb-react-table-editor';
import { MDBAlert } from 'mdb-react-ui-kit';

export default function App() {
  const advancedColumns: AdvancedHeader[] = [
    {
      width: 250,
      label: 'Company',
      field: 'company',
    },
    {
      width: 250,
      sort: false,
      defaultValue: 'Warsaw',
      options: ['London', 'Warsaw', 'New York'],
      inputType: 'select' as 'number' | 'select' | 'checkbox',
      label: 'Office',
      field: 'office',
    },
    {
      width: 250,
      inputType: 'number' as 'number' | 'select' | 'checkbox',
      defaultValue: 1,
      label: 'Employees',
      field: 'employees',
    },
    {
      width: 100,
      defaultValue: false,
      inputType: 'checkbox' as 'number' | 'select' | 'checkbox',
      label: 'International',
      field: 'international',
    },
  ];

  const advancedRows: AdvancedRecord[] = [
    {
      company: 'Smith & Johnson',
      office: 'London',
      employees: 30,
      international: true,
    },
    {
      company: 'P.J. Company',
      office: 'London',
      employees: 80,
      international: false,
    },
    {
      company: 'Food & Wine',
      office: 'London',
      employees: 12,
      international: false,
    },
    {
      company: 'IT Service',
      office: 'London',
      employees: 17,
      international: false,
    },
    {
      company: 'A. Jonson Gallery',
      office: 'London',
      employees: 4,
      international: false,
    },
    {
      company: 'F.A. Architects',
      office: 'London',
      employees: 4,
      international: false,
    },
  ];

  const [notificationData, setNotificationData] = useState({
    columns: advancedColumns,
    rows: advancedRows,
  });

  const [addAlert, setAddAlert] = useState(false);
  const [deleteAlert, setDeleteAlert] = useState(false);
  const [updateAlert, setUpdateAlert] = useState(false);

  const [alertBody, setAlertBody] = useState({ company: '', office: '' });

  return (
    <>
      <MDBTableEditor
        data={notificationData}
        entriesOptions={[5, 10, 15]}
        entries={5}
        onAdd={(newRow) => {
          setAlertBody({ company: newRow.company as string, office: newRow.office as string });
          setNotificationData({ ...notificationData, rows: [...notificationData.rows, newRow] });

          setAddAlert(true);
          setTimeout(() => {
            setAddAlert(false);
          }, 2000);
        }}
        onModify={(modifiedData, id) => {
          setAlertBody({
            company: modifiedData[id].company as string,
            office: modifiedData[id].office as string,
          });
          setNotificationData({ ...notificationData, rows: modifiedData });

          setUpdateAlert(true);
          setTimeout(() => {
            setUpdateAlert(false);
          }, 2000);
        }}
        onDelete={(id) => {
          setAlertBody({
            company: notificationData.rows[id].company as string,
            office: notificationData.rows[id].office as string,
          });
          setNotificationData({ ...notificationData, rows: notificationData.rows.filter((row, i) => i !== id) });

          setDeleteAlert(true);
          setTimeout(() => {
            setDeleteAlert(false);
          }, 2000);
        }}
      />

      <MDBAlert open={addAlert} color='success' autohide width={360} position='top-right' delay={2000} appendToBody>
        <strong>New entry: </strong>
        {alertBody.company} ({alertBody.office})
      </MDBAlert>
      <MDBAlert
        open={updateAlert}
        color='primary'
        autohide
        width={360}
        position='top-right'
        delay={2000}
        appendToBody
      >
        <strong>Updated entry: </strong>
        {alertBody.company} ({alertBody.office})
      </MDBAlert>
      <MDBAlert open={deleteAlert} color='danger' autohide width={360} position='top-right' delay={2000} appendToBody>
        <strong>Deleted entry: </strong>
        {alertBody.company} ({alertBody.office})
      </MDBAlert>
    </>
  );
}

Dark

Dark mode can be applied to both modal and inline versions - firstly, add a CSS class which changes the background color to your page. Secondly, pass the same class name to the color option of your Table Editor (f.e. 'bg-dark'). Now change the font to light by setting dark attribute to true.


Company Address Employees
Smith & Johnson Park Lane 2, London 30
P.J. Company Oak Street 7, Aberdeen 80
Food & Wine Netherhall Gardens 3, Hampstead 12
IT Service Warwick Road 14, London 17
A. Jonson Gallery Oaklands Avenue 2, London 4
F.A. Architects Frognal Way 7, Hampstead 4
import React, { useState } from 'react';
import { MDBTableEditor } from 'mdb-react-table-editor';

export default function App() {
  const advancedColumns = [
    {
      width: 250,
      label: 'Company',
      field: 'company',
    },
    {
      width: 250,
      sort: false,
      defaultValue: 'Warsaw',
      options: ['London', 'Warsaw', 'New York'],
      inputType: 'select',
      label: 'Office',
      field: 'office',
    },
    {
      width: 250,
      inputType: 'number',
      defaultValue: 1,
      label: 'Employees',
      field: 'employees',
    },
    {
      width: 100,
      defaultValue: false,
      inputType: 'checkbox',
      label: 'International',
      field: 'international',
    },
  ];

  const advancedRows = [
    {
      company: 'Smith & Johnson',
      office: 'London',
      employees: 30,
      international: true,
    },
    {
      company: 'P.J. Company',
      office: 'London',
      employees: 80,
      international: false,
    },
    {
      company: 'Food & Wine',
      office: 'London',
      employees: 12,
      international: false,
    },
    {
      company: 'IT Service',
      office: 'London',
      employees: 17,
      international: false,
    },
    {
      company: 'A. Jonson Gallery',
      office: 'London',
      employees: 4,
      international: false,
    },
    {
      company: 'F.A. Architects',
      office: 'London',
      employees: 4,
      international: false,
    },
  ];

  const [darkData, setDarkData] = useState({
    columns: advancedColumns,
    rows: advancedRows,
  });

  return (
    <MDBTableEditor
      dark
      data={darkData}
      entriesOptions={[5, 10, 15]}
      setData={(e: any) => setDarkData({ ...darkData, rows: e })}
    />
  );
}

Table editor - API


Import

import { MDBTableEditor } from 'mdb-react-ui-kit';

Properties

MDBTableEditor

Name Type Default Description Example
actionHeader ReactNode 'Actions' Header for action buttons <MDBTableEditor actionHeader='custom header' />
actionPosition String 'start' | 'end' Decides where to render an action column (start/end) <MDBTableEditor actionPosition='end' />
advancedSearch SelectData[] - Allows searching only for values in specific column <MDBTableEditor advancedSearch={[ { text: 'All columns', value: '' }, { text: 'Company', value: 'company' }, { text: 'Office', value: 'office' }, ]} />
allText string 'All' Changes text for All in the pagination select. <MDBTableEditor allText='test' />
bordered boolean false Adds borders to a TableEditor. <MDBTableEditor bordered />
borderless boolean false Removes all borders from a TableEditor. <MDBTableEditor borderless />
borderColor string - Changes a border color to one of main colors. <MDBTableEditor borderColor='red' />
cancelText ReactNode 'Cancel' Text displayed in cancel buttons <MDBTableEditor cancelText='Cancel' />
confirmText ReactNode 'Delete' Text displayed in confirm buttons (Popconfirm) <MDBTableEditor confirmText='custom confirm text' />
confirmMessage ReactNode 'Are you sure you want to delete this entry?' Text displayed in a Popconfirm element <MDBTableEditor confirmMessage='custom confirm message' />
color string - Adds a color class to a TableEditor (f.e 'bg-dark') <MDBTableEditor color='primary' />
data DataType - Data passed to the TableEditor. <MDBTableEditor data={data} />
dark boolean false Changes a font color to white. <MDBTableEditor dark />
editable boolean true Enable the edit mode. <MDBTableEditor editable />
editItemHeader ReactNode 'Edit item' A header of modal <MDBTableEditor editItemHeader='Adding item' />
entries number 10 Number of visible entries (pagination). <MDBTableEditor entries={25} />
entriesOptions number[] [10, 25, 50, 200] Options available to choose from in a pagination select (rows per page). <MDBTableEditor entriesOptions=[10, 20, 60] />
fixedHeader boolean false When it's set to true, the table's header will remain visible while scrolling. <MDBTableEditor fixedHeader />
format (field: string | number | symbol, value: number) => CSSProperties | undefined; - Allows formatting cells <MDBTableEditor format={(field, value) => { if (field === 'age' && value > 60) { return { backgroundColor: '#999' }; } }} />
fullPagination boolean false Displays additional buttons for the first and last pages. <MDBTableEditor fullPagination />
hover boolean false Changes the background color of a hovered row. <MDBTableEditor hover />
isLoading boolean false Set the loading mode. <MDBTableEditor isLoading />
loaderClass string 'bg-primary' The class name for a loader (loading mode). <MDBTableEditor loaderClass='bg-warning' />
loadingMessage ReactNode 'Loading results...' A message displayed while loading data. <MDBTableEditor loadingMessage='Loading...' />
maxWidth string - Sets a maximum width of a TableEditor - can be either a string ('10%') or a number of pixels. <MDBTableEditor maxWidth='560px' />
maxHeight string - Sets a maximum height of a TableEditor - can be either a string ('10%') or a number of pixels. <MDBTableEditor maxHeight='560px' />
mode 'table' | 'modal' 'table' Set table editor mode. <MDBTableEditor mode='modal' />
newItemHeader ReactNode 'New item' A header of modal <MDBTableEditor newItemHeader='Adding item' />
noFoundMessage ReactNode 'No matching results found' A message displayed when a table is empty. <MDBTableEditor noFoundMessage='Not found...' />
ofText ReactNode 'of' 'of' text in the pagination <MDBTableEditor ofText='z' />
pagination boolean true Shows/hides the pagination panel. <MDBTableEditor pagination={false} />
saveText ReactNode 'Save' Text displayed in the save button (modal)
rowsText string 'Rows per page': A text indicating a number of rows per page. <MDBTableEditor rowsText='Rows:' />
search boolean false Enable search in the table. <MDBTableEditor search />
sm boolean false Decreases a row's paddings. <MDBTableEditor sm />
striped boolean false Slightly changes the background's color in every other row. <MDBTableEditor striped />
sortField string '' Allows default sorting of the table column <MDBTableEditor sortField='ColumnName' />
sortOrder string 'asc' Defines the default sorting direction <MDBTableEditor sortField='ColumnName' sortOrder='desc' />
searchInputProps Record<string, unknown> - Props for the search input <MDBTableEditor searchInputProps={{ className: 'test' }} />

Properties

DataType

type DataType = {
  columns: ColumnsType;
  rows: RowsType;
};

ColumnsType

type AdvancedHeader = {
  label: string;
  field: keyof AdvancedRecord;
  sort?: boolean;
  width?: number;
  fixed?: string;
  fixedValue?: number;
  defaultValue?: unknown;
  options?: string[];
  inputType?: 'number' | 'select' | 'checkbox';
};

type ColumnsType = AdvancedHeader[];

RowsType

type AdvancedRecord = Record<string, unknown>;

type RowsType = AdvancedRecord[];

Events

Name Type Description
onRowClick (row: RecordsType) => void Event emitted after clicking on a row.
onAdd (row: AdvancedRecord) => void This event fires after adding a new row.
onModify (rows: RowsType, id: number) => void This event fires when user modifies row.
onDelete (id: number) => void This event fires after deleting a row.